/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.plugin.java.map;
import javax.swing.JPanel;

import org.objectweb.util.browser.api.Panel;
import org.objectweb.util.browser.api.TreeView;

/**
 * Provides a panel with a title displaying the map size.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class MapTitlePanel 
  implements Panel 
{

    //==================================================================
    //
    // Internal state.
    //
    //==================================================================

    /** The panel to provide */
    protected javax.swing.JPanel panel_;

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for Panel interface.
    //
    //==================================================================

    /**
     * Creates a panel with a title displaying the map size.
     */
    public void selected(TreeView treeView) 
    {    
        // Obtains the selected map.
        java.util.Map map = (java.util.Map)treeView.getSelectedObject();
        
        // Creates and customizes the panel.
        panel_ = new JPanel();
        panel_.setBackground(java.awt.Color.WHITE);
        panel_.add(new javax.swing.JLabel("Map Entries (" + map.size() + " entries)"));
    }

    /**
     * Returns the title panel.
     */
    public JPanel getPanel() 
    {
        return panel_;
    }

    /**
     * When unselected.
     */
    public void unselected(TreeView treeview) 
    {
        // Nothing to do !
    }

}

