/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.plugin.java.reflect;

import java.net.URL;
import java.util.jar.JarFile;

/**
 * 
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class JarFileStructure {


    //==================================================================
    //
    // Internal states.
    //
    //==================================================================
    
    protected JarFile jarFile_ = null;
    
    protected URL jarURL_ = null;

    //==================================================================
    //
    // Constructors.
    // 
    //==================================================================

    public JarFileStructure(JarFile jarFile, URL jarURL) {
        jarFile_ = jarFile;
        jarURL_ = jarURL;   
    }

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public method.
    //
    //==================================================================

    public JarFile getJarFile(){
        return jarFile_;
    }

    public URL getJarURL(){
        return jarURL_;
    }
    
}

