/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.core.popup;

/** The browser's imports */
import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.core.api.MenuItemTreeViewConfiguration;
import org.objectweb.util.browser.core.common.DefaultTreeView;
import org.objectweb.util.browser.core.common.DynamicTree;

/** The Java API's imports */
import java.awt.event.ActionEvent;

/**
 *
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class DefaultMenuItemTreeView
     extends DefaultTreeView 
  implements MenuItemTreeView, MenuItemTreeViewConfiguration {

    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    protected ActionEvent actionEvent_ = null;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

/*    public DefaultMenuItemTreeView(ActionEvent e, DynamicTree tree) {
        super(tree);
        actionEvent_ = e;
    }
*/
    public DefaultMenuItemTreeView(DynamicTree tree) {
        super(tree);
    }

    public DefaultMenuItemTreeView(DynamicTree tree, Entry entry) {
        super(tree, entry);
    }

    // ==================================================================
    //
    // Public methods from MenuItemTreeView interface.
    //
    // ==================================================================

    /** 
     * Returns the initial ActionEvent
     */
    public ActionEvent getActionEvent() {
        return actionEvent_;
    }

    // ==================================================================
    //
    // Public methods from MenuItemTreeViewConfiguration interface.
    //
    // ==================================================================

    /**
     * Fixes the associated action event
     * @param e The associated action event
     */
    public void setActionEvent(ActionEvent e){
        actionEvent_ = e;
    }

}
