/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s): .

====================================================================*/

package org.objectweb.openccm.corba.trader;

import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.SpecifiedServiceTypes;
import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.IncarnationNumber;

/**
 * Wrapper class in order to manipulate the
 * CosTrading::Lookup::SpecifiedProps union independently of the used
 * ORB product.
 *
 *  @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain.Leblanc</a>
 *
 *  @version 0.1
 */
public class SpecifiedServiceTypesWrapper {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     *  The default constructor.
     */
    public SpecifiedServiceTypesWrapper() {}

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public static methods.
    //
    // ==================================================================

    /**
     * Creates a
     * CosTradingRepos::ServiceTypeRepository::SpecifiedServiceTypes
     * union with discriminator initialized with the ListOption.all
     * value.
     *
     * @return A
     * CosTradingRepos::ServiceTypeRepository::SpecifiedServiceTypes
     * union object.
     */
    public static SpecifiedServiceTypes
    create_all() {
        SpecifiedServiceTypes sst = new SpecifiedServiceTypes();
        sst.__default();
        return sst;
        
    }

    /**
     * Creates a
     * CosTradingRepos::ServiceTypeRepository::SpecifiedServiceTypes
     * union with discriminator initialized with the HowManyProps.since
     * value.
     *
     * @return A
     * CosTradingRepos::ServiceTypeRepository::SpecifiedServiceTypes
     * union object.
     */
    public static SpecifiedServiceTypes
    create_since(IncarnationNumber num) {
        SpecifiedServiceTypes sst = new SpecifiedServiceTypes();
        sst.incarnation(num);
        return sst;
        
    }
}
