/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
package org.omg.lifl.eclipse.plugin.PopUpMenu.popup.actions;

import java.io.IOException;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import org.omg.lifl.eclipse.plugin.utils.OSHelper;
import org.omg.lifl.eclipse.plugin.utils.WorkBenchHelper;

public class LaunchShellAction implements IObjectActionDelegate {

    /**
     * Constructor for LaunchShellAction.
     */
    public LaunchShellAction() {
        super();
    }

    /**
     * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
     */
    public void setActivePart(IAction action, IWorkbenchPart targetPart) {
    }

    /**
     * @see IActionDelegate#run(IAction)
     */
    public void run(IAction action) {
        //WorkBenchHelper.log();

        String srciptCmd = null;
        if (OSHelper.isWindowsOS()) { // Windows OS
            srciptCmd =
                OSHelper.createWin32Shell()
                    + WorkBenchHelper.getSelectedRessourceFullFileName();
        } else if (OSHelper.isLinuxOS()) { // Linux OS
            srciptCmd = null;
            return; //create exec command for linux shell
        } else // other OS
            return;
        
        try {
            OSHelper.launchProcess(srciptCmd);

        } catch (IOException e) {
            // the shell command cannot be launch 
            e.printStackTrace();
        }
    }

    /**
     * @see IActionDelegate#selectionChanged(IAction, ISelection)
     */
    public void selectionChanged(IAction action, ISelection selection) {
    }

}
