/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 3 juin 2003 by jerome OFFROY (offroy@lifl.fr)
 *
 */

package org.omg.lifl.eclipse.plugin.project.OpenCCM;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.omg.lifl.eclipse.plugin.project.OpenCCM.utils.ValidatorProject;
import org.omg.lifl.eclipse.plugin.project.utils.AttributeManager;

/**
 * @author offroy
 *
 */
public class ProjectChooser {
	private String _NameLabel;
	private String _ProjectName;
	private Text fTextControl;
	private ValidatorProject page;
	
	/**
	 * Constructor
	 */
	public ProjectChooser(IConfigurationElement elem) {
		_NameLabel = AttributeManager.getAttribute(elem, "label");
		_ProjectName = AttributeManager.getAttribute(elem, "name");
	}
	
	/**
	 * @param composite
	 */
	public void viewToSetOpenCCMProjectName(Composite composite, ValidatorProject validator) {
		this.page = validator;
		Composite internal = new Composite(composite, SWT.NONE);
		GridLayout gd = new GridLayout();
		gd.numColumns = 2;

		GridLayout gd2 = new GridLayout();
		gd2.numColumns = 2;

		internal.setLayout(gd);
		Label label = new Label(internal, SWT.LEFT);
		label.setText(_NameLabel);
		label.setLayoutData(new GridData());
		fTextControl = new Text(internal, SWT.SINGLE | SWT.BORDER);

		fTextControl.setText(_ProjectName);
		fTextControl.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				if (!fTextControl.isDisposed() && page != null) {
					page.validateTextProjectName(fTextControl.getText());
				}
			}
		});
		fTextControl.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
	}
	
	/**
	 * @return
	 */
	public String get_NameLabel() {
		return _NameLabel;
	}

	/**
	 * @param string
	 */
	public void set_NameLabel(String string) {
		_NameLabel = string;
	}

	/**
	 * @return
	 */
	public String get_ProjectName() {
		return _ProjectName;
	}

	/**
	 * @param string
	 */
	public void set_ProjectName(String string) {
		_ProjectName = string;
	}

	/**
	 * @return
	 */
	public Text getFTextControl() {
		return fTextControl;
	}

	/**
	 * @param text
	 */
	public void setFTextControl(Text text) {
		fTextControl = text;
	}

}
