/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 27 juin 2003
 *
 */
package org.omg.lifl.eclipse.plugin.utils;

import java.util.Vector;

import org.eclipse.swt.graphics.Point;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.omg.lifl.eclipse.plugin.shell.views.OpenCCMConsole;

/**
 * @author offroy
 *
 */
public class OutputToConsole {
    private static String err;
    private static String out;
    private static OpenCCMConsole console;
    private static StringBuffer textBuffer = new StringBuffer();
    private static Vector errorHighlight = new Vector();

    public static boolean init()
    {
        IWorkbenchWindow window;
        IWorkbench workbench = PlatformUI.getWorkbench();
        window = workbench.getActiveWorkbenchWindow();
        if(window == null)
            return false;
        IWorkbenchPage page = window.getActivePage();
        if(page == null)
            return false;
        try
        {
            console = (OpenCCMConsole)page.findView(OpenCCMConsole.CONSOLE_ID);
            if(console == null)
            {
                page.showView(OpenCCMConsole.CONSOLE_ID);
                console = (OpenCCMConsole)page.findView("org.omg.lifl.eclipse.plugin.shell.views.OpenCCMConsole");
            }
            if (console == null) System.out.println("console null");
        }
        catch(PartInitException e)
        {
            e.printStackTrace();
        }
        if(err == null)
            err = "";
        if(out == null)
            out = "";
        if(err == null)
            if(out != null);
        return true;
    }

    public static void addError(String errorString)
    {
        errorHighlight.addElement(new Point(textBuffer.length(), errorString.length() - 1));
        textBuffer.append(errorString);
    }

    public static void addOutString(String outString)
    {
        textBuffer.append(outString);
    }

    public static void clear()
    {
        textBuffer = new StringBuffer();
        errorHighlight = new Vector();
        start();
    }

    public static void start()
    {
        console.refresh(textBuffer.toString(), errorHighlight);
    }


    /**
     * @return
     */
    public static OpenCCMConsole getConsole() {
        return console;
    }

    /**
     * @param console
     */
    public static void setConsole(OpenCCMConsole console) {
        OutputToConsole.console = console;
    }

}
