package ist.coach.coachEmfClientComponents.gui;

//import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

import javax.swing.DefaultCellEditor;

import javax.swing.JScrollPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import java.awt.*;
import java.awt.event.*;
import java.util.Hashtable;
import java.util.Vector;

/**
 * This is exactly like TableDemo, except that it uses a
 * custom cell editor to validate integer input.
 */
public class AttributesFrame extends JFrame
implements ActionListener{

	GuiMaster master;
	//String parent_key;
	String object_type;
	String visual_object_class;
	ParamTableModel myModel;
	String [] param_name = null;
	boolean[] param_options = null;
	MOTreeObject tree_object;

    public AttributesFrame( String object_class,
							//String parent_key,
							MOTreeObject tree_object,
							Object[] values,
							GuiMaster master,
            				int x_pos, int y_pos) {

		super(GuiMessages.options_properties);
		this.master = master;
		this.tree_object = tree_object;
		//this.parent_key = parent_key;
		visual_object_class = object_class;

		try {
			param_name  = (String [])Class.forName(object_class).getDeclaredField("attributes_name").get(null);
			object_type = (String)Class.forName(object_class).getDeclaredField("object_type").get(null);
			param_options  = (boolean [])Class.forName(object_class).getDeclaredField("attributes_readonly").get(null);

		}
		catch(java.lang.IllegalArgumentException e1) {
			System.err.println("IllegalArgumentException");
		}
		catch(java.lang.IllegalAccessException e2) {
			System.err.println("IllegalAccessException");
		}
		catch(java.lang.ClassNotFoundException e3) {
			System.err.println("ClassNotFoundException" + e3.getMessage());
		}
		catch(java.lang.NoSuchFieldException e4) {
			System.err.println("NoSuchFieldException");
		}


        myModel = new ParamTableModel(param_name, values, param_options);
        JAttributesTable table = new JAttributesTable(myModel);
        table.setPreferredScrollableViewportSize(new Dimension(300, 70));
		table.setCellSelectionEnabled(true);

        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);

        JButton update_button = new JButton(GuiMessages.update_str);
        update_button.addActionListener(this);
        update_button.setToolTipText(GuiMessages.update_tooltip_str);

        JButton cancel_button = new JButton(GuiMessages.cancel_str);
        cancel_button.addActionListener(this);
        cancel_button.setToolTipText(GuiMessages.cancel_tooltip_str);

        JPanel submitPanel = new JPanel(new FlowLayout());
        submitPanel.add(update_button);
        submitPanel.add(cancel_button);

        //Add the scroll pane to this window.
        getContentPane().add(scrollPane, BorderLayout.CENTER);
        getContentPane().add(submitPanel, BorderLayout.SOUTH);

		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        /*****
		addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
	   *****/
		setLocation(x_pos, y_pos);
        pack();
        setVisible(true);
    }

	public void actionPerformed(ActionEvent e) {

		if (e.getActionCommand().equals(GuiMessages.update_str)) {

			Hashtable updates = new Hashtable();
			int table_size = myModel.getRowCount();
			for(int i = 0; i < table_size ; i++) {

                if (! myModel.isCellEditable(i, 1))
                    continue;

				updates.put(myModel.getValueAt(i, 0),
							myModel.getValueAt(i, 1));
			}

/*****
		try {
			Class objectClass = Class.forName(visual_object_class);
			java.lang.reflect.Method[] theMethods = objectClass.getMethods();
			for (int i = 0; i < theMethods.length; i++) {
				System.err.println("Method[" + i + "] = " +
							theMethods[i].getName() + " returns " +
								theMethods[i].getReturnType().getName()  +
						" has parameters: ");

				Class [] parametersT =  theMethods[i].getParameterTypes();
				for(int k=0; k < parametersT.length; k++)
					System.err.println("\t[" + k + "] = " + parametersT[k].getName());
			}

			Class[] partypes = new Class[1];
			partypes[0] = (new Hashtable()).getClass();
			java.lang.reflect.Method translate_updates = objectClass.getMethod(
					"translate_updates", partypes);

			Object[] arguments = { updates };
			//System.err.println("Before invoking method...");
			Vector retobj = (Vector) translate_updates.invoke(null,
													arguments);
		}
		catch(java.lang.IllegalArgumentException e1) {
			System.err.println("AttributesFrame> IllegalArgumentException");
		}
		catch(java.lang.IllegalAccessException e2) {
			System.err.println("AttributesFrame> IllegalAccessException");
		}
		catch(java.lang.ClassNotFoundException e3) {
			System.err.println("AttributesFrame> ClassNotFoundException" +
				e3.getMessage());
		}
		catch(java.lang.NoSuchMethodException e4) {
			System.err.println("AttributesFrame> NoSuchMethodException" +
				e4.getMessage());
			e4.printStackTrace();
		}
		catch(java.lang.reflect.InvocationTargetException e5) {
			System.err.println("AttributesFrame> InvocationTargetException");
		}
*****/
			Vector retobj = tree_object.translate_updates(updates);

			if (retobj == null || retobj.size() == 0) {
					JOptionPane.showMessageDialog(this,
						GuiMessages.update_nothing_error,
						GuiMessages.options_update,
						JOptionPane.WARNING_MESSAGE);

					this.dispose();
					return;
			}

			if (master.setAttributes( (String) myModel.getValueAt(0, 1), retobj)) {
					JOptionPane.showMessageDialog(this,
						GuiMessages.reply_ok,
						GuiMessages.options_update,
						JOptionPane.WARNING_MESSAGE);

			}
			else {
					JOptionPane.showMessageDialog(this,
						GuiMessages.reply_error,
						GuiMessages.options_update,
						JOptionPane.WARNING_MESSAGE);
			}
	}
		 this.dispose();
    }
}
