package ist.coach.coachEmfClientComponents.gui;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableModel;
import java.awt.Color;

public class JAlarmTable
extends JTable {


	DefaultTableCellRenderer eventTypeRenderer;
	DefaultTableCellRenderer readonlyRenderer;
	DefaultTableCellRenderer detailsRenderer;
	DefaultTableCellRenderer heartbeatTypeRenderer;
	DefaultTableCellRenderer channelChangeRenderer;

	AlarmTableModel alarmData;

	public JAlarmTable(AlarmTableModel dm) {
		super(dm);

		alarmData = dm;
		eventTypeRenderer = new DefaultTableCellRenderer();
		eventTypeRenderer.setForeground(Color.blue);
		eventTypeRenderer.setFont(new java.awt.Font("Helvetica",
												java.awt.Font.BOLD, 10));

		detailsRenderer = new DefaultTableCellRenderer();
		detailsRenderer.setFont(new java.awt.Font("Helvetica",
					    java.awt.Font.BOLD, 6));

		readonlyRenderer =  new DefaultTableCellRenderer();

		heartbeatTypeRenderer = new DefaultTableCellRenderer();
		heartbeatTypeRenderer.setForeground(Color.green);

		channelChangeRenderer = new DefaultTableCellRenderer();
		channelChangeRenderer.setForeground(Color.orange);

		getTableHeader().setFont(new java.awt.Font("Helvetica",
                                    java.awt.Font.BOLD, 12));
	}

	public TableCellRenderer getCellRenderer(int row, int column) {

		if (((String) alarmData.getValueAt(row, AlarmTableModel.EVENT_C)).
		  trim().equals(GuiMaster.HEARTBEAT_ALARM))
		  return heartbeatTypeRenderer;

		if (((String) alarmData.getValueAt(row, AlarmTableModel.EVENT_C)).
		  trim().equals(GuiMaster.CHANNEL_CHANGE_ALARM))
		  return channelChangeRenderer;

		if (column == AlarmTableModel.EVENT_C)
			return eventTypeRenderer;
		if (column == AlarmTableModel.DETAILS_C)
		    return detailsRenderer;

		return readonlyRenderer;
	}
}
