package ist.coach.coachEmfClientComponents.gui;

import javax.swing.ImageIcon;

import intt.itu.itut_x780.ManagedObjectValueType;
import ist.coach.coachEmsMib.IpRoutingEntryValueType;
import ist.coach.coachEmfClientComponents.InvokeSetData;

import ist.coach.coachEmfCommon.Utils;
public class VisualIpRoutingEntry
extends MOTreeObject {

    static String[] subordinate_names = new String[0];

    static boolean canRefresh = false;
    static String object_type = "IpRoutingEntry";
    static String emsClassName = "ist.coach.coachEmsMib.IpRoutingEntry_F";

	static String DISPLAY_TYPE = "IP Routing Entry";

	//
    // create arguments
    //
    static String[] create_arg_name =  new String[0];
    static String[] create_arg_editor =  new String[0];
    static String[] create_arg_renderer =  new String[0];
    //
    // get/set arguments
    //

    static String[] attributes_name = {     //ManagedObject
                                        "Name",
                                        "Element Type",
                                        "Creation Source",
                                        "Delete Policy",
											//IpRoutingEntry
										"Destination IP Address",
										"Logical Interface Index",
										"Primary Routing Metric",
										"Alternate Routing Metric",
										"Alternate Routing Metric",
										"Alternate Routing Metric",
										"IP Address of Next Hop",
										"Type of Route",
										"Routing Protocol",
										"Seconds since Last Update",
										"Subnet Mask",
										"Alternate Routing Metric",
										"MIB Object Identifier"

					};

	 static boolean[] attributes_readonly =  {
						  //ManagedObject
                    false,
                    false,
                    false,
                    false,
						  //IpRoutingEntry
                    false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false

	};

	public VisualIpRoutingEntry(String key) {
		super(key);
		leafIcon = new ImageIcon(VisualIpRoutingEntry.class.getResource(
                "images/iproutingentry_icon.gif"));
		nodeIcon = new ImageIcon(VisualIpRoutingEntry.class.getResource(
                "images/iproutingentry_icon.gif"));
		 toolTipText = new String(DISPLAY_TYPE);
	}

	public Object[] translate_values(ManagedObjectValueType original_value_type) {

		Object[] values = new Object[attributes_name.length];
        for (int i = 0; i < values.length; i++)
            values[i] = "unspecified";

        if (original_value_type == null)
            return values;

        Object[] mo_values = super.translate_values(original_value_type);
        int i = 0;
        for (i = 0; i < mo_values.length; i++)
            values[i] = mo_values[i];

		IpRoutingEntryValueType value_type;
        value_type = (IpRoutingEntryValueType) original_value_type;

		if (value_type.ipRouteDest != null && value_type.ipRouteDest.length > 0)
		  values[i] = new String(value_type.ipRouteDest);
		i++;

		values[i++] = String.valueOf(value_type.ipRouteIfIndex);
		values[i++] = String.valueOf(value_type.ipRouteMetric1);

		if (value_type.ipRouteMetric2 > 0)
		  values[i] = String.valueOf(value_type.ipRouteMetric2);
		i++;

		if (value_type.ipRouteMetric3 > 0)
		  values[i] = String.valueOf(value_type.ipRouteMetric3);
		i++;

		if (value_type.ipRouteMetric4 > 0)
		  values[i] = String.valueOf(value_type.ipRouteMetric4);
		i++;

		if (value_type.ipRouteNextHop != null && value_type.ipRouteNextHop.length > 0)
		  values[i] = new String(value_type.ipRouteNextHop);
		i++;

		//values[i++] = String.valueOf(value_type.ipRouteType);
		switch(value_type.ipRouteType) {
		case 1:
			values[i] = new String("Other (neither direct/indirect/invalid)");
			break;
		case 2:
			values[i] = new String("Invalidated Route");
			break;
		case 3:
			values[i] = new String("Route to directly connected sub-network");
			break;
		case 4:
			values[i] = new String("Route to a non-local host/network/sub-network");
			break;
		default:
			break;
		}
		i++;

		//values[i++] = String.valueOf(value_type.ipRouteProto);
		switch(value_type.ipRouteProto) {
		case 1:
			values[i] = new String("Other (neither local/setted by management/routing protocol)");
			break;
		case 2:
			values[i] = new String("Local (manually configured)");
			break;
		case 3:
			values[i] = new String("Set via management protocol");
			break;
		case 4:
			values[i] = new String("ICMP obtained");
			break;
		case 5:
			values[i] = new String("EGP gateway routing protocol");
			break;
		case 6:
			values[i] = new String("GGP gateway routing protocol");
			break;
		case 7:
			values[i] = new String("HELLO gateway routing protocol");
			break;
		case 8:
			values[i] = new String("RIP gateway routing protocol");
			break;
		case 9:
			values[i] = new String("IS-IS gateway routing protocol");
			break;
		case 10:
			values[i] = new String("ES-IS ateway routing protocol");
			break;
		case 11:
			values[i] = new String("CISCO IGRP gateway routing protocol");
			break;
		case 12:
			values[i] = new String("BbnSpfIGP gateway routing protocol");
			break;
		case 13:
			values[i] = new String("OSPF gateway routing protocol");
			break;
		case 14:
			values[i] = new String("BGP gateway routing protocol");
			break;
		default:
			break;
		}
		i++;
		if (value_type.ipRouteAge > 0)
		  values[i] = String.valueOf(value_type.ipRouteAge);
		i++;

		if (value_type.ipRouteMask != null && value_type.ipRouteMask.length > 0)
		  values[i] = new String(value_type.ipRouteMask);
		i++;

		if (value_type.ipRouteMetric5 > 0)
		  values[i] = String.valueOf(value_type.ipRouteMetric5);
		i++;
		if (value_type.ipRouteInfo != null && value_type.ipRouteInfo.length() > 0)
		  values[i] = value_type.ipRouteInfo;
		i++;

/**
		switch(value_type.ipAdEntBcastAddr) {
		case 1:
			values[i++] = new String("Internet standard all-ones");
			break;
		default:
			values[i++] = String.valueOf(value_type.ipAdEntBcastAddr);
			break;
		}

  ****/

		return values;
    }

    java.util.Vector translate_updates(java.util.Hashtable values) {

		return new java.util.Vector();
	}
}
