package ist.coach.coachEmfClientComponents.gui;

import javax.swing.ImageIcon;

import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.AdministrativeStateType;
import intt.itu.itut_x780.OperationalStateType;
import intt.itu.itut_x780.UsageStateType;
import ist.coach.coachEmsMib.LogicalInterfaceValueType;
import ist.coach.coachEmfClientComponents.InvokeSetData;

import ist.coach.coachEmfCommon.Utils;
public class VisualLogicalInterface 
extends MOTreeObject {

	static String[] subordinate_names = new String[0];
//	static String[] subordinate_vtype = new String[0];

		// HACK
		// This must be the type declared in idl as objectClass!!!!!
	static String object_type = "LogicalInterface";
	static String emsClassName = "ist.coach.coachEmsMib.LogicalInterface_F";

	static String DISPLAY_TYPE = "Logical Interface";
	static boolean canRefresh = false;
	//
	// create arguments
	//
	static String[] create_arg_name =  new String[0];
	static String[] create_arg_editor =  new String[0];
	static String[] create_arg_renderer =  new String[0];
	//
	// get/set arguments
	//

	static String[] attributes_name = { 		//ManagedObject
										"Name", 
										"Element Type",
                                        "Creation Source",
                                        "Delete Policy",
												//TP
										"Related Objects",
										"Operational State",
												//Logical Interface
										"Administrative State",
										"Interface Index",
										"Description",
										"Physical/MAC Type",
                                        "Maximum Transfer Unit (MTU)",
                                        "Bandwidth (bps)",
                                        "Physical Address",
										"Last State Change Time",
										"Number of Received Octets",
										"Incoming Unicast Packets Served",
										"Incoming Non Unicast Packets Served",
										"Incoming Packets Discarded",
										"Incoming Erroneous Packets",
										"Incoming Unsupported Packets Received",
										"Number of Sent  Octets",
										"Outgoing Unicast Packets Served",
										"Outgoing Non Unicast Packets Served",
										"Outgoing Packets Discarded",
										"Outgoing Erroneous Packets",
										"Length of Output Queue",
										"MIB Object Identifier"
					};
							
	static boolean[] attributes_readonly =  {
					false,
					false,
					false,
					false,
					false,
					false,
					false, //true,
					false,
					false,
					false,
					false,
					false,
					false,
					false, //true,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false,
					false
	};

	//settable arguments
	static int ADMIN_POS = 6;
	static int LASTCANGE_POS = 13;

public VisualLogicalInterface(String key) {

	super(key);
	leafIcon = new ImageIcon(VisualLogicalInterface.class.getResource(
				"images/logicalinterface_icon.gif"));
	nodeIcon = new ImageIcon(VisualLogicalInterface.class.getResource(
					"images/logicalinterface_icon.gif"));
	toolTipText = new String(DISPLAY_TYPE);


}

	public Object[] translate_values(ManagedObjectValueType original_value_type) {

		Object[] values = new Object[attributes_name.length];
		for (int i = 0; i < values.length; i++)
			values[i] = "unspecified";

		if (original_value_type == null) 
			return values;

		Object[] mo_values = super.translate_values(original_value_type);
        int i = 0;
        for (i = 0; i < mo_values.length; i++)
            values[i] = mo_values[i];

		LogicalInterfaceValueType value_type;
		value_type = (LogicalInterfaceValueType) original_value_type;

			//
			// TP
			//
			//related objects...
		String related_objs_str = "unspecified";
		for (int j = 0; j < value_type.supportedByObjectList.length; j++ ) {
			if (value_type.supportedByObjectList[j] != null) {
				related_objs_str += Utils.name2string(
							value_type.supportedByObjectList[j]); 
			}
			if (j < value_type.supportedByObjectList.length -1 )
				related_objs_str += ", ";
		}
		values[i++] = related_objs_str;

		switch(value_type.operationalState.value()) {
			case OperationalStateType._disabled :
				values[i++] = new String("Disabled");
				 break;
            case OperationalStateType._enabled :
				values[i++] = new String("Enabled");
				break;
			default:
                values[i++] = new String("Unknown");
        }

			//
			// LogicalInterface
			//
		//values[i++] = String.valueOf(value_type.ifAdminStatus);
		switch(value_type.ifAdminStatus) {
			case ist.coach.coachEmsMib.LogicalInterface_F.up :
			case ist.coach.coachEmsMib.LogicalInterface_F.testing :
				values[i++] = new String("Up");
				break;
			case ist.coach.coachEmsMib.LogicalInterface_F.down :
					values[i++] = new String("Disabled");
					break;
			default:
				values[i++] = new String("Unknown");
		}
		values[i++] = String.valueOf(value_type.ifIndex);

		String sysDescr = value_type.ifDescr;
		if (sysDescr != null && sysDescr.length() > 0)
			values[i] = sysDescr;	
		i++;

		values[i++] = String.valueOf(value_type.ifType);
		values[i++] = String.valueOf(value_type.ifMtu);
		values[i++] = String.valueOf(value_type.ifSpeed);

		if (value_type.ifPhysAddress != null && 
				value_type.ifPhysAddress.length > 0) {

			//values[i] = new String(value_type.ifPhysAddress);

			String hexAddressStr = new String();	
			String shortStr = new String();
			for (int j = 0; j < value_type.ifPhysAddress.length; j++) {
				hexAddressStr += Integer.toHexString( 
					new Byte((value_type.ifPhysAddress[j])).intValue() & 0x000000ff);

				if (j < value_type.ifPhysAddress.length - 1)
				 	hexAddressStr  += ":";
			}
			values[i] = hexAddressStr;

		}
		else
			values[i] = "none";
		i++;

		if (value_type.ifLastChange >= 0)
			values[i] = String.valueOf(value_type.ifLastChange);
		i++;
		values[i++] = String.valueOf(value_type.ifInOctets);
		values[i++] = String.valueOf(value_type.ifInUcastPkts);

		if (value_type.ifInNUcastPkts >= 0)
			values[i] = String.valueOf(value_type.ifInNUcastPkts);
		i++;

		values[i++] = String.valueOf(value_type.ifInDiscards);

		values[i++] = String.valueOf(value_type.ifInErrors);

		if (value_type.ifInUnknownProtos >= 0)
			values[i] = String.valueOf(value_type.ifInUnknownProtos);
		i++;

		values[i++] = String.valueOf(value_type.ifOutOctets);
		values[i++] = String.valueOf(value_type.ifOutUcastPkts);

		if (value_type.ifOutNUcastPkts >= 0)
			values[i] = String.valueOf(value_type.ifOutNUcastPkts);
		i++;

		values[i++] = String.valueOf(value_type.ifOutDiscards);

		values[i++] = String.valueOf(value_type.ifOutErrors);
		values[i++] = String.valueOf(value_type.ifOutQLen);

		String ifSpecific = value_type.ifSpecific;
		if (ifSpecific!= null && ifSpecific.length()> 0)
			values[i] = ifSpecific;
		i++;

		return values;
	}

	java.util.Vector translate_updates(java.util.Hashtable values) {

		java.util.Vector updates = new java.util.Vector();
		org.omg.CosNaming.NameComponent[] objectName = Utils.string2name(key);
			
		if (values.containsKey(attributes_name[ADMIN_POS])) {

			String attr_value_str = (String) values.get(attributes_name[ADMIN_POS]);
			if (attr_value_str != null && attr_value_str.length() > 0) {

				int attr_value = Integer.parseInt(attr_value_str);

            	Object[] arg_val = {objectName, new Integer(attr_value)};
            	InvokeSetData data_set = new InvokeSetData(emsClassName,
							"ifAdminStatusSet",
                            arg_val
            	);
            	updates.add(data_set);
			}
        }

		if (values.containsKey(attributes_name[LASTCANGE_POS])) {

			String attr_value_str = (String) values.get(attributes_name[LASTCANGE_POS]);

			if (attr_value_str != null && attr_value_str.length() > 0) {

                int attr_value = Integer.parseInt(attr_value_str);


            	Object[] arg_val = {objectName, new Integer(attr_value)};
            	InvokeSetData data_set = new InvokeSetData(emsClassName,
							"ifLastChangeSet",
                            arg_val
            	);
            	updates.add(data_set);
			}
        }
            return updates;
    }

}
