package ist.coach.coachEmfCommon;

import org.omg.CosNaming.NameComponent;
import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;


public class CreateController {

	public static synchronized CreateBindingInfo checkNameBinding(String nameBinding_str)
	throws CreateError{

		short deletePolicy = -1;
        boolean managerMayCreatePolicy = false;
        String objectKind = new String();

		CreateBindingInfo info = new CreateBindingInfo();

		try {
            Class deletePolicyClass =
                Class.forName(nameBinding_str + ".deletePolicy");

            deletePolicy =
                deletePolicyClass.getDeclaredField("value").getShort(null);

            Class managerMayCreatePolicyClass =
                    Class.forName(nameBinding_str + ".managersMayCreate");
            managerMayCreatePolicy =
                managerMayCreatePolicyClass.getDeclaredField("value").getBoolean(null);

            Class objectKindClass =
                     Class.forName(nameBinding_str + ".kind");
            objectKind = ((String) objectKindClass.getDeclaredField("value").get(null)).trim();

           // System.err.println("deletePolicy = " + deletePolicy +
             //                   "managerMayCreatePolicy = " + managerMayCreatePolicy +
               //                 "objectKind = " + objectKind);
        }
        catch(java.lang.ClassNotFoundException ex) {
            System.err.println(nameBinding_str + " can not be found!" + ex.getMessage());
            CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value);
	           error_code.details = ExceptionMessages.namebinding_exists_error;
            throw new CreateError(error_code);
		}
        catch(java.lang.NoSuchFieldException ex_field) {
            System.err.println("java.lang.NoSuchFieldException caught " +
                    ex_field.getMessage());
            CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value);

            error_code.details = ExceptionMessages.namebinding_field_error;
            throw new CreateError(error_code);
        }
        catch(java.lang.IllegalAccessException ex_acc) {
            System.err.println("java.lang.IllegalAccessException caught " +
                    ex_acc.getMessage());
            CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value);

            error_code.details = ExceptionMessages.namebinding_field_error;
            throw new CreateError(error_code);
        }

		info.objectKind = objectKind;
		info.deletePolicy = deletePolicy;
		return info;
		//return new CreateBindingInfo(deletePolicy, objectKind);
	}

	public static synchronized String autoCreateId(NameComponent[][] siblings) {

		String allocatedId =  new String();

		//System.err.println("Auto-naming gets activated..");
		//System.err.println("Parent has " + siblings.length +
          //          " children");

		boolean idFound = false;
   		int id = 0, name_length = 0;

    	while(! idFound) {
            id++;
            int i = 0;
            for(i = 0; i < siblings.length; i++) {
                if (siblings[i] !=null && (name_length=siblings[i].length) > 0) {
                   // -fset update to allow fancy autonaming (prepending description)
				   // if (siblings[i][name_length -2].id.equals(Integer.toString(id))) {
					  if (siblings[i][name_length -2].id.indexOf(Integer.toString(id)) >= 0) {
                        break;
                    }
                }
            }
            if (i >= siblings.length)  {
                idFound = true;
            }
        }
        allocatedId = Integer.toString(id);
		return allocatedId;
	}


	public static synchronized NameComponent[] createFullName(NameComponent[] superior,
										String allocatedId,
										String facade_name,
										String objectKind) {

	    org.omg.CosNaming.NameComponent[] name;

        int index = 0;
        if (superior.length == 1) {
            name = new org.omg.CosNaming.NameComponent[superior.length + 2];
                index = 1;
        }
        else {
            name = new org.omg.CosNaming.NameComponent[superior.length + 1];
                index = superior.length - 1;
        }
        int i = 0;
        for(i = 0; i < index; i++)
            name[i] = superior[i];
            // the before-last name component, contains the element's id info
        name[i++] = new org.omg.CosNaming.NameComponent(allocatedId, objectKind);

            // the last component contains the facade's info;
        name[i] = new org.omg.CosNaming.NameComponent("", facade_name);

		return name;
	}

};
