/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfServicesComponents.AlarmChannelProviderComposition;


/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmfServicesComponents/AlarmChannelProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class AlarmChannelProviderImpl
     extends ist.coach.coachEmfServicesComponents.AlarmChannelProviderComposition.AlarmChannelProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
	public static final String OBJECT_TYPE = "AlarmChannelProvider";
		/* business logic */
	private String _channelId = "Undefined";
	private String[] _sourceClasses = null;
	private String[] _excludedSourceClasses = null;
	private String[] _eventTypes = null;
	private String[] _excludedEventTypes = null;
	intt.itu.itut_q816.ChannelFinderComponent channel_finder = null;

		/* This boolean signifies that any change in the properties should trigger 
			notification of ChannelFinder
		 */
	private boolean postInit = false;
	private org.omg.CORBA.Object myself;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public AlarmChannelProviderImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::channelId attribute as accessor operation.
     */
    public String
    channelId()
    {
       //
        //  DONE : implement
        //
        return _channelId;
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::channelId attribute as mutator operation.
     */
    public void
    channelId(String channelId)
    {
        //
        //  DONE : implement
        //
		if (channelId != null && ! "undefined".equals(channelId))
			_channelId = new String(channelId);

		System.err.println("Channel Id is set to " + _channelId);
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::sourceClasses attribute as accessor operation.
     */
    public String[]
    sourceClasses()
    {
        //
        //  DONE : implement
        //
        return _sourceClasses;
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::sourceClasses attribute as mutator operation.
     */
    public void
    sourceClasses(String[] sourceClasses)
    {
        //
        //  DONE : implement
        //
		System.err.print(channelId() + "AlarmChannelProvider will serve:");
		if (sourceClasses == null)
			_sourceClasses = new String[0];
		else
			_sourceClasses = sourceClasses;

		if (postInit) 
			performUpdate();

		for (int i = 0; i < _sourceClasses.length; i++)
			System.err.print(_sourceClasses[i] + ", ");
		System.err.println();
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedSourceClasses attribute as accessor operation.
     */
    public String[]
    excludedSourceClasses()
    {
        //
        //  DONE : implement
        //
        return _excludedSourceClasses;
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedSourceClasses attribute as mutator operation.
     */
    public void
    excludedSourceClasses(String[] excludedSourceClasses)
    {
        //
        //  DONE : implement
        //
		if (excludedSourceClasses == null)
			_excludedSourceClasses = new String[0];
		else
			_excludedSourceClasses = excludedSourceClasses;

		if (postInit) 
			performUpdate();

    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::eventTypes attribute as accessor operation.
     */
    public String[]
    eventTypes()
    {
       //
        //  DONE : implement
        //
        return _eventTypes;
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::eventTypes attribute as mutator operation.
     */
    public void
    eventTypes(String[] eventTypes)
    {
        //
        //  DONE : implement
        //

		if (eventTypes == null)
			_eventTypes = new String[0];
		else
			_eventTypes = eventTypes;

		if (postInit) 
			performUpdate();

		System.err.println(channelId() + " " + _eventTypes.length + " eventTypes supported..");
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedeventTypes attribute as accessor operation.
     */
    public String[]
    excludedeventTypes()
    {
        //
        //  DONE : implement
        //
        return _excludedEventTypes;
    }

    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_AlarmChannelProvider_Executor::excludedeventTypes attribute as mutator operation.
     */
    public void
    excludedeventTypes(String[] excludedeventTypes)
    {
        //
        //  DONE : implement
        //
		if (excludedeventTypes == null)
			_excludedEventTypes = new String[0];
		else
			_excludedEventTypes = excludedeventTypes;

		if (postInit) 
			performUpdate();

    }

	public void performUpdate() {

		try {
			channel_finder.update(_channelId,
								OBJECT_TYPE,
								_eventTypes,
								_excludedEventTypes,
								_sourceClasses,
								_excludedSourceClasses,
								myself);

		}
		catch(intt.itu.itut_x780.ApplicationError ex) {
			System.err.println("Application Error exception caught while updating " +
				"AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}
		catch(intt.itu.itut_q816.ChannelNotFound channel_ex) {
			System.err.println("ChannelAlreadyRegistered  exception caught while updating " +
                "AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}
	}
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		System.err.println("AlarmChannelProvider configuration started...");
		channel_finder = get_context().get_connection_channelfinder_admin();

		if (channel_finder == null || _channelId == null) {
			System.err.println("AlarmChannelProvider failed to locate ChannelFinder!");
			throw new org.omg.Components.InvalidConfiguration();
		}

		if (_sourceClasses == null || _sourceClasses.length == 0) {
			System.err.println("Alarm Channel sourceClasses are not set..Proceeding manually");
			_sourceClasses = new String[1];
			_sourceClasses[0] = "IpNode";

			_excludedSourceClasses =  new String[0];
		}

		if (_eventTypes == null || _eventTypes.length == 0) {
			System.err.println("Alarm Channel eventTypes are not set..Proceeding manually");
			_eventTypes = new String[6];
			_eventTypes[0] = "ObjectCreation";
			_eventTypes[1] = "ObjectDeletion";
			_eventTypes[2] = "StateChangedEvent";
			_eventTypes[3] = "Heartbeat";
			_eventTypes[4] = "ChannelChangeEvent";
			_eventTypes[5] = "OperationalViolation";

			_excludedEventTypes = new String[0];
		}


		try {

			//org.omg.CORBA.Object myself =
			myself =
				((org.omg.Components.SessionContext) get_context()).get_CCM_object();
			if (myself == null)
			System.err.println("AlarmChannelProvider there is a problem getting myself as a component!");

			channel_finder.register(_channelId,
									OBJECT_TYPE,
									_eventTypes,
									_excludedEventTypes,
									_sourceClasses,
									_excludedSourceClasses,
									myself);

		}
		catch(intt.itu.itut_x780.ApplicationError ex) {
			System.err.println("Application Error exception caught while registering " +
				"AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}
		catch(intt.itu.itut_q816.ChannelAlreadyRegistered channel_ex) {
			System.err.println("ChannelAlreadyRegistered  exception caught while registering " +
                "AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}
		catch(org.omg.Components.IllegalState state_ex) {
			System.err.println("org.omg.Components.IllegalState  exception caught while registering " +
                "AlarmChannelProvider " + _channelId + " to ChannelFinder");
		}

		postInit = true;
		System.err.println(_channelId + " AlarmChannelProvider configuration completed...");


    }

    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // DONE: implement !!!
        //
		try {
			channel_finder.unregister(_channelId);
		}
		catch(intt.itu.itut_q816.ChannelNotFound channel_ex) {
			System.err.println("ChannelNotFound exception caught unregistering " +
				_channelId + " from ChannelFinderService ");

		}
		catch(intt.itu.itut_x780.ApplicationError ex) {
			System.err.println("ApplicationError exception caught unregistering " +
				_channelId + " from ChannelFinderService ");
		}
    }
}
