/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_x780Components.ManagedObjectProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;


import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ManagedObjectValueTypeImpl;

import ist.coach.coachEmfCommon.ObjectDeletionImpl;

import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.UIDType;

import org.omg.CosNaming.NameComponent;
import ist.coach.coachEmfServices.EmfBasicLog.*;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/itut_x780Components/ManagedObjectProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class ManagedObjectProviderImpl
     extends ist.coach.itut_x780Components.ManagedObjectProviderComposition.ManagedObjectProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
	private String _facade_name;

	protected static java.util.Hashtable elements;
	private static int notifId = 100;
	private BasicLog logSupport;


    /**
     **  Context reference.
     **/

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public ManagedObjectProviderImpl()
    {}
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================

    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		elements = new java.util.Hashtable();
		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();
		System.err.println(facade_name() + " configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */

    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
	    Utils.pretty_log(logSupport, "System Monitor", facade_name(), (short) LogSeverity._Info,
		  "ManagedObject monitoring is shutting down...");
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_ManagedObjectProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_x780Components/CCM_ManagedObjectProvider/get_mgmt:1.0
    //
    /**
     **  Implementation of the ::itut_x780Components::CCM_ManagedObjectProvider::get_mgmt operation.
     **/
    //public ist.coach.itut_x780Components.CCM_ManagedObjectMgmt
    //get_mgmt()
    //{
    //    return this;
    //}
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     */
    public String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     */
    public void
    facade_name(String facade_name)
    {
        //
        //  DONE : implement
        //
		if (facade_name != null)
			_facade_name = new String(facade_name);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     */
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        // DO : Implement
        //
        return Utils.string2name(_facade_name);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     */
    public String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.objectClass;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     */
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
// TESTING LOG
//org.omg.CORBA.Any record, ist.coach.coachEmfServices.EmfBasicLog.NVPair[] nv)

/***************************
		System.err.println("ManagedObjectProvider> Proceeding to invoke the Log Service");
		try {
		  logSupport.flush();
		}
		catch(Exception e) {
			System.err.println("ManagedObjectProvider> flush " + e.getMessage());
		}
		System.err.println("ManagedObjectProvider> Log Service call returned");
		System.err.println("ManagedObjectProvider> Log Service records: " +
		  logSupport.get_n_records());
***************************/
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name), (short) LogSeverity._Info,
		  "attributesGet successfully finished");

		//System.err.println("ManagedObjectProvider> Log Service invoked ok: " +
		//  logSupport.get_n_records());

//END OF TESTING
		return mo_value;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     */
    public String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.packages;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     */
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.creationSource;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     */
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
	    //
        //  DONE : implement
        //

		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.deletePolicy;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     */
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,
               intt.itu.itut_x780.DeleteError
    {
	    //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);

		}
		ManagedObjectValueType mo_value = null;
		synchronized(elements) {
		    mo_value =
			(ManagedObjectValueType) elements.remove(Utils.name2string(name));
		}
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);
		get_context().push_objectDeletion_alarm(new ObjectDeletionImpl(eventTime, name,
										mo_value.objectClass,
										getUniqueNotificationIdentifier(),
										mo_value.creationSource,
										new AttributeValueType[0]));

		Utils.pretty_log(logSupport, Utils.name2string(name), mo_value.objectClass, (short) LogSeverity._Info,
		 "Object  successfully removed");
    }

    synchronized static int getUniqueNotificationIdentifier() {

        notifId++;

       return (notifId);
   }
}
