/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents.IpNodeFactoryProviderComposition;

import org.omg.CosNaming.NameComponent;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.CreateController;
import ist.coach.coachEmfCommon.CreateBindingInfo;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmsCommon.SnmpUtils;

import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;
import ist.coach.coachEmsCommon.SnmpIdentifiers;

import ist.coach.coachEmsMib.conditionalPackages.sysInfoSetPackageType;
import ist.coach.coachEmsMib.conditionalPackages.snmpEnableAuthenTrapPackageType;

import ist.coach.coachEmsMib.IpNodeFactory;
import ist.coach.coachEmsMib.IpAddressDataFactory;
import ist.coach.coachEmsMib.LogicalInterfaceFactory;
import ist.coach.coachEmsMib.IpProtocolMonitorFactory;
import ist.coach.coachEmsMib.SnmpProtocolMonitorFactory;
//import ist.coach.coachEmsMib.LogicalInterfaceFactoryHelper;
//import ist.coach.coachEmsMib.IpProtocolMonitorFactoryHelper;

import ist.coach.coachEmsMib.IpNodeFactoryHelper;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.ManagedObjectFactoryHelper;
import intt.itu.itut_x780.ManagedObjectFactory;

import intt.itu.itut_m3120.conditionalPackages.*;

import org.opennms.protocols.snmp.SnmpSMI;

import ist.coach.coachEmsMibComponents.IpNodeMgmt;
import ist.coach.coachEmfServices.EmfBasicLog.*;

/**
 **  Implementation skeleton class for the ::coachEmsMibComponents::IpNodeFactoryProvider component.
 **/
public class IpNodeFactoryProviderImpl
extends ist.coach.coachEmsMibComponents.IpNodeFactoryProviderComposition.IpNodeFactoryProvider_impl
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/

   /* Business logic **/
    intt.itu.itut_q816.ContainmentComponent c_admin = null;
    intt.itu.itut_q816.Containment c_query = null;
	//ist.coach.coachEmsMib.LogicalInterfaceFactory logicalInterfaceFactory = null;

	private static final String FACTORY_CLASS = "IpNodeFactory";
	IpNodeMgmt facade = null;

	ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	private org.omg.CORBA.ORB orb = null;

	private static final String SYS_CONTACT_OID = SnmpIdentifiers.SYS_CONTACT_OID;
	private static final String SYS_NAME_OID = SnmpIdentifiers.SYS_NAME_OID;
    private static final String SYS_LOCATION_OID = SnmpIdentifiers.SYS_LOCATION_OID;
    private static final String [] IP_GROUP_OIDS = {

					SnmpIdentifiers.IP_FWD_TYPE_OID,
					SnmpIdentifiers.IP_DEFAULT_TTL_OID,
					SnmpIdentifiers.IP_INRECEIVE_OID,
					SnmpIdentifiers.IP_INHDRERRORS_OID,
					SnmpIdentifiers.IP_INADDRERRORRS_OID,
					SnmpIdentifiers.IP_FWDDATAGRAMS_OID,
					SnmpIdentifiers.IP_INUNKNOWNPROTO_OID,
					SnmpIdentifiers.IP_INDISCARDS_OID,
					SnmpIdentifiers.IP_INDELIVERS_OID,
					SnmpIdentifiers.IP_OUTREQUESTS_OID,
					SnmpIdentifiers.IP_OUTDISCARDS_OID,
					SnmpIdentifiers.IP_NOROUTE_OID,
					SnmpIdentifiers.IP_REASMTIMEOUT_OID,
					SnmpIdentifiers.IP_REASMREQ_OID,
					SnmpIdentifiers.IP_REASMOK_OID,
					SnmpIdentifiers.IP_REASMFAIL_OID,
					SnmpIdentifiers.IP_FRAGOK_OID,
					SnmpIdentifiers.IP_FRAGFAIL_OID,
					SnmpIdentifiers.IP_FRAGCREATE_OID,
					SnmpIdentifiers.IP_ROUTING_DISCARDS_OID
	};
	private static final String [] SNMP_GROUP_OIDS = {

			SnmpIdentifiers.SNMP_INPKTS_OID,
			SnmpIdentifiers.SNMP_OUTPKTS_OID,
			SnmpIdentifiers.SNMP_INBADVERSIONS_OID,
			SnmpIdentifiers.SNMP_INBADCOMMUNITYNAME_OID,
			SnmpIdentifiers.SNMP_INBADCOMMUNITYUSES_OID,
			SnmpIdentifiers.SNMP_INASNPARSEERRORS_OID,
			SnmpIdentifiers.SNMP_INTOOBIG_OID,
			SnmpIdentifiers.SNMP_INNOSUCHNAMES_OID,
			SnmpIdentifiers.SNMP_INBADVALUES_OID,
			SnmpIdentifiers.SNMP_INREADONLYS_OID,
			SnmpIdentifiers.SNMP_INGENERRS_OID,
			SnmpIdentifiers.SNMP_INTOTALREQVARS_OID,
			SnmpIdentifiers.SNMP_INTOTALSETVARS_OID,
			SnmpIdentifiers.SNMP_INGETREQS_OID,
			SnmpIdentifiers.SNMP_INGETNEXTS_OID,
			SnmpIdentifiers.SNMP_INSETREQS_OID,
			SnmpIdentifiers.SNMP_INGETRESPONSES_OID,
			SnmpIdentifiers.SNMP_INTRAPS_OID,
			SnmpIdentifiers.SNMP_OUTTOOBIG_OID,
			SnmpIdentifiers.SNMP_OUTNOSUCHNAMES_OID,
			SnmpIdentifiers.SNMP_OUTBADVALUES_OID,
			SnmpIdentifiers.SNMP_OUTGENERRS_OID,
			SnmpIdentifiers.SNMP_OUTGETREQS_OID,
			SnmpIdentifiers.SNMP_OUTGETNEXTS_OID,
			SnmpIdentifiers.SNMP_OUTSETREQS_OID,
			SnmpIdentifiers.SNMP_OUTGETRESPONSES_OID,
			SnmpIdentifiers.SNMP_OUTTRAPS_OID,
			SnmpIdentifiers.SNMP_ENABLEAUTHTRAPS_OID
	};

	private static final String READ_COMMUNITY = SnmpIdentifiers.READ_COMMUNITY;
	private static final String NO_SUCH_OBJECT = "No Such Object";
	private static final String NO_SUCH_INSTANCE = "No Such Instance";

	private BasicLog logSupport;

    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    IpNodeFactoryProviderImpl()
    {
    }

    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
	    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
        if ((facade = get_context().get_connection_facade()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_admin = get_context().get_connection_containment_admin()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_query = get_context().get_connection_containment_query()) == null)
            throw new org.omg.Components.InvalidConfiguration();

		    // If managers may create, then the factory must register to the
            // factory finder service
        intt.itu.itut_q816.FactoryFinderComponent factoryfinder_admin =
            get_context().get_connection_factoryfinder_admin();

		if ((connector = get_context().get_connection_connector()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		 org.omg.CORBA.Object myself_o;
		 IpNodeFactory myself = null;

        try {
			myself_o = ((org.omg.Components.SessionContext) get_context()).get_CCM_object();
        	myself = IpNodeFactoryHelper.narrow(myself_o);

            factoryfinder_admin.register(FACTORY_CLASS, myself);
        }
        catch(intt.itu.itut_x780.ApplicationError ex) {
            throw new org.omg.Components.InvalidConfiguration();
        }
		catch(Exception e) {
			System.err.println("IpNodeFactory has problems retrieving CCM component");
		}

        this.orb = org.objectweb.ccm.CORBA.TheORB.getORB();

        System.err.println("IpNodeFactoryProvider configuration completed...");

    }

    // ==================================================================
    //
    // Public methods for the CCM_IpNodeFactoryProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMib/IpNodeFactory/create_ipNode:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNodeFactory::create operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    create( java.lang.String nameBinding,
			org.omg.CosNaming.NameComponent[] superior,
			java.lang.String reqID,
			java.lang.String[] packageNameList,
			java.lang.String domainName,
			java.lang.String hostname,
			byte[]  managementIPAddress,
			int supportedSnmpVersions,
			intt.itu.itut_x780.AdministrativeStateType administrativeState,
			java.lang.String userLabel,
			java.lang.String vendorName,
			java.lang.String version,
			java.lang.String locationName,
			int snmpPort,
			java.lang.String sysName,
			java.lang.String sysContact)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //  DONE : implement
        //

        String nameBinding_str = "ist.coach.coachEmsMib.NameBindings." +
                nameBinding;

//		String objectKind = CreateController.checkNameBinding(nameBinding_str);

		CreateBindingInfo info = CreateController.checkNameBinding(nameBinding_str);

		String objectKind = info.objectKind;
		short deletePolicy = info.deletePolicy;

        // Check if the parent exists
        if (! c_query.exists(superior)) {
            ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value);

            error_code.details = Utils.name2string(superior) +
                            ExceptionMessages.parent_object_error;

            throw new ApplicationError(error_code);
        }

        // The system must have the capability of auto-naming objects
        String allocatedId = reqID;
        if (reqID == null || reqID.length() == 0) {

            org.omg.CosNaming.NameComponent[][] siblings =
                c_query.getContained(superior);

				allocatedId = CreateController.autoCreateId(siblings);
        }

        // Construct the name of the new object
        org.omg.CosNaming.NameComponent[] name = CreateController.createFullName(
					superior,
					allocatedId,
					Utils.name2facade(facade.facade_name()),
					objectKind);

        // Decide the conditional packages that are supported.
        String [] supportedConditionalPackages = packageNameList;

		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "proceed to create " + Utils.name2string(name));

		if (packageNameList.length == 0) {

            //System.err.println("No packages are specified." +
            //    "Trying to determine supported packages...");

            if (vendorName.equalsIgnoreCase("Linux") ||
                vendorName.equalsIgnoreCase("RedHat Linux")  ||
                vendorName.equalsIgnoreCase("RedHat")) {

                //System.err.println("IpNodeFactoryProvider>Found linux System...");
/*****
                System.err.println("supported packages:");
                System.err.println("\t" + sysInfoSetPackageType.value);
                System.err.println("\t" + locationNamePackageType.value);
                System.err.println("\t" + userLabelPackageType.value);
                System.err.println("\t" + vendorNamePackageType.value);
                System.err.println("\t" + versionPackageType.value);
*******/
                supportedConditionalPackages = new String[5];

                supportedConditionalPackages[0] = sysInfoSetPackageType.value;
                supportedConditionalPackages[1] = locationNamePackageType.value;
                supportedConditionalPackages[2] = userLabelPackageType.value;
                supportedConditionalPackages[3] = vendorNamePackageType.value;
                supportedConditionalPackages[4] = versionPackageType.value;
            }
        }
        else {
            System.err.println("Factory will not determine supported conditional Packages," +
                " because Manager already specified them.");
        }


        if (Utils.packageIsSupported(sysInfoSetPackageType.value, supportedConditionalPackages)) {

			//System.err.println("sysName: " + sysName);

            org.omg.CORBA.Any sysNameValue = orb.create_any();
			org.omg.CORBA.OctetSeqHelper.insert(sysNameValue, sysName.getBytes());

			DataTypeImpl sysNameDataType = new DataTypeImpl(SYS_NAME_OID,
			  sysNameValue, SnmpSMI.SMI_STRING);


               //by digi
			//sysNameValue.insert_string(sysName);
            //DataTypeImpl sysNameDataType = new DataTypeImpl(SYS_NAME_OID,
	  	   // sysNameValue, SnmpSMI.SMI_STRING);

			//System.err.println("sysContact: " + sysContact);
            org.omg.CORBA.Any sysContactValue = orb.create_any();
            org.omg.CORBA.OctetSeqHelper.insert(sysContactValue, sysContact.getBytes());//sysName.getBytes());

            DataTypeImpl sysContactDataType = new DataTypeImpl(SYS_CONTACT_OID,
                sysContactValue, SnmpSMI.SMI_STRING);
				//by digi
			    //sysContactValue.insert_string(sysContact);
				//DataTypeImpl sysContactDataType = new DataTypeImpl(SYS_CONTACT_OID,
				//sysContactValue, SnmpSMI.SMI_STRING);

            DataTypeImpl [] sysData = {sysNameDataType, sysContactDataType};

            try {
                connector.setBulk(
                    sysData,
                    new String(managementIPAddress),
                    snmpPort,
                    SnmpIdentifiers.WRITE_COMMUNITY); //"private"
            }
            catch (SnmpApplicationError e) {

				CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
             	error_code.error = new UIDType(
               	  	intt.itu.itut_x780.CreateErrorConst.moduleName.value,
               	  	intt.itu.itut_x780.CreateErrorConst.unsupportedPackages.value);

             		error_code.details = e.reason;

        	     throw new CreateError(error_code);
            }
			catch(Exception e) {
			  System.err.println("IpNodeFactory> Exception caught:" + e.getMessage());
			  e.printStackTrace(System.err);
			}
        }

        if (Utils.packageIsSupported(locationNamePackageType.value, supportedConditionalPackages)) {

            org.omg.CORBA.Any sysLocationValue = orb.create_any();

			org.omg.CORBA.OctetSeqHelper.insert(sysLocationValue, locationName.getBytes());

           // by digi
		   //sysLocationValue.insert_string(locationName);
            DataTypeImpl sysLocationDataType = new DataTypeImpl(SYS_LOCATION_OID,
                sysLocationValue, SnmpSMI.SMI_STRING);

            try {
                connector.set(
                    sysLocationDataType,
                    new String(managementIPAddress),
                    snmpPort,
                    "private");
            }
            catch (SnmpApplicationError e) {

             CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
             error_code.error = new UIDType(
                 intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                 intt.itu.itut_x780.CreateErrorConst.unsupportedPackages.value);

             error_code.details = e.reason;
             throw new CreateError(error_code);
            }
			catch (Exception e) {
			  System.err.println("System exception caught:" + e.getMessage());
			  e.printStackTrace(System.err);
			}

        }

        //System.err.println("IpNodeFactory> Before invoking the facade " +
          //          Utils.name2facade(facade.facade_name()) + " to create " + Utils.name2string(name));

        facade.create(name, objectKind, supportedConditionalPackages, deletePolicy,
                    intt.itu.itut_x780.SourceIndicatorType.managementOperation,
					domainName,
					hostname,
					managementIPAddress,
					supportedSnmpVersions,
					administrativeState,
					userLabel,
					vendorName,
					version,
					locationName,
					(short)snmpPort,
					sysName,
					sysContact);

		 //System.err.println("IpNodeFactory>Before registering to the containment service");
		 c_admin.addName(name, superior);
		//System.err.println("IpNodeFactory>After registering to the containment service");

		System.err.println("IpNodeFactory> Proceeding to perform SNMP updates...");
	    NameComponent[][] logical_interface_subordinates = new NameComponent[0][0];
		DataType[] ifTable = new DataType[0];
		try {
			ifTable = this.connector.getSnmpTable(
				//LogicalInterfaceProviderImpl.IF_TABLE_OID,
            	SnmpIdentifiers.IF_TABLE_OID,
					new String(managementIPAddress),
            		snmpPort,
				    SnmpIdentifiers.READ_COMMUNITY); // "public"
		}
		catch(ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
			System.err.println("SnmpApplicationError caught> " +
						snmp_ex.reason);
				return name;
		}
		catch(Exception e) {
		  System.err.println("IpNodeFactory: create>Exception caught: " + e.getMessage());
		  e.printStackTrace(System.err);
		}

		int[] indexRows = { 1 };
		int [] ifTableIndexes = SnmpUtils.getIntColumnData(ifTable,
			18, indexRows);

		int[] ifDescrIndexRows = { 2 };
		String [] ifTableIfDescrs = SnmpUtils.getOctetColumnData(ifTable,
			18, ifDescrIndexRows);

		if (ifTableIndexes == null) {
			System.err.println("Indexes could not be determined for" +
				" Logical Interfaces. No Logical Interface objects will" +
				" be created.");
		}
		else
		if (ifTableIndexes.length == 0)
			System.err.println("No LogicalInterface objects found");
		else
		if (ifTableIfDescrs.length == 0)
			System.err.println("Could not determine interface descriptions " +
				"for Logical Interface Objects");
		else
		if (ifTableIfDescrs.length != ifTableIndexes.length)
			System.err.println("Mapping of ifDescr is not one-to-one with " +
				"Logical Interface objects");
		else {

			LogicalInterfaceFactory lif =
			  get_context().get_connection_logicalInterfaceFactory();

			if (lif == null)
				System.err.println("Factory is null..." +
					" No LogicalInterface Objects will be created.");
			else {

				//System.err.println("IpNodeFactoryProvider>******FOUND " +
				//    ifTableIndexes.length +
				//	" LogicalInterface Objects");

				String [] logicalInterfacePackages = new String[0];

            	if (vendorName.equalsIgnoreCase("Linux") ||
               		vendorName.equalsIgnoreCase("RedHat Linux")  ||
               		vendorName.equalsIgnoreCase("RedHat")) {

               		//System.err.println("IpNodeFactoryProvider:create> Found linux System..." +
					//	"No package is supported for LogicalInterface");
				}
				logical_interface_subordinates = new NameComponent[ifTableIndexes.length][0];
				for (int i = 0; i < ifTableIndexes.length; i++) {

						logical_interface_subordinates[i] = lif.create(
															  "LogicalInterface_IpNode",
															  name,
															  ifTableIfDescrs[i],
															  logicalInterfacePackages,
															  ifTableIndexes[i],
															  managementIPAddress,
															  snmpPort,
															  supportedSnmpVersions,
															  ifTableIfDescrs[i]);
				}
			}
		}

		// IpProtocolMonitor creation
		try {

			DataType[] res = this.connector.getBulk(
					IP_GROUP_OIDS,
            		new String(managementIPAddress),
            		snmpPort,
					READ_COMMUNITY);

			int count = 0;

			for (int i = 0; i < res.length; i++) {
				try {
					if ( (res[i].value.extract_string().equalsIgnoreCase(
						NO_SUCH_OBJECT)) ||
						(res[i].value.extract_string().equalsIgnoreCase(
						NO_SUCH_INSTANCE)) )
					count ++;
				}
				catch (org.omg.CORBA.BAD_OPERATION badOp) {
					// If a string cannot be extracted, then the result
					// will not be "No Such Object", or "No Such Instance"
					// so no problem then! Catch this exception and ignore it.
				}
			}

			if (count < res.length) {
				//System.err.println("IpProtocolMonitor must be created.");

				IpProtocolMonitorFactory ipf =
				   get_context().get_connection_ipProtocolMonitorFactory();

				if (ipf == null) {
					System.err.println("IpProtocolMonitorFactory is null..." +
						" No IpProtocolMonitor Object will be created!");
				}
				else {
					//System.err.println("Invoking IpProtocolMonitorFactory...");

					String [] ipProtocolMonitorPackages = new String[0];

            		if (vendorName.equalsIgnoreCase("Linux") ||
                		vendorName.equalsIgnoreCase("RedHat Linux")  ||
                		vendorName.equalsIgnoreCase("RedHat")) {

                		//System.err.println("Found linux System..." +
						//	"No package is supported for IpProtocolMonitor");
					}

					ipf.create(
						"IpProtocolMonitor_IpNode",
						name,
						"IpProtocol",
						ipProtocolMonitorPackages,
						managementIPAddress,
						snmpPort,
						supportedSnmpVersions
					);

				}
			} // IpProtocolMonitor must be created
		}
		catch (SnmpApplicationError e) {
			System.err.println("\nIpNodeFactory:SnmpApplicationError while trying to create IpProtocolMonitorFactory");
			System.err.println("Reason:" + e.reason);

			// Continue to create other objects, if possible...
		}
        //System.err.println("IpNodeFactory>create returns for " + Utils.name2string(name));

			  //IpAddressData creation
//
//FSET TESTS FOR IPADDTRESSDATA
//

		DataType[] ipTable = new DataType[0];
		try {
			ipTable = this.connector.getSnmpTable(
				    SnmpIdentifiers.IP_ADDR_TABLE_OID,
					new String(managementIPAddress),
            		snmpPort,
				    READ_COMMUNITY);
		}
		catch(ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
			System.err.println("SnmpApplicationError caught> " +
						snmp_ex.reason);
				return name;
		}
		catch(Exception e) {
		  System.err.println("IpNodeFactory: create>Exception caught: " + e.getMessage());
		  e.printStackTrace(System.err);
		}
//		System.err.println("IP Address Table Size = " +  ipTable.length);

		int[] ipAdEntAddrIndexRows = { 1 };
		String [] ipAdEntAddresses = SnmpUtils.getStringColumnData(ipTable,
			4, ipAdEntAddrIndexRows);
/***************************************
		System.err.println("ipAdEntAddresses Table Size = " +  ipAdEntAddresses.length);
		for(int ip_index = 0; ip_index < ipAdEntAddresses.length; ip_index++) {
			System.err.println("ipAdEntAddresses[" + ip_index + "] = " +
			    ipAdEntAddresses[ip_index]);
		}
******************************************/
		int[] ipAdEntIfIndexRows = { 2 };
		int [] ipAdEntIfIndexes = SnmpUtils.getIntColumnData(ipTable,
			4, ipAdEntIfIndexRows);

	/********************
	 	System.err.println("ipAdEntIfIndexRows Table Size = " +  ipAdEntIfIndexRows.length);
		for(int ip_index = 0; ip_index < ipAdEntIfIndexes.length; ip_index++) {
			System.err.println("ipAdEntIfIndexes[" + ip_index + "] = " +
				  ipAdEntIfIndexes[ip_index]);
		}
	***********************/
		if (ipAdEntAddresses == null) {
			System.err.println("IpNodeFactory> Indexes could not be determined for" +
				" Ip Address Data. No IPAddressData objects will" +
				" be created.");
		}
		else
		if (ipAdEntAddresses.length == 0)
			System.err.println("IpNodeFactory> No IPAddressData objects found");
		else
		if (ipAdEntIfIndexes.length == 0)
			System.err.println("IpNodeFactory> Could not determine interface index " +
				"for IpAddressData Objects");
		else
		if (ipAdEntIfIndexes.length != ipAdEntAddresses.length)
			System.err.println("IpNodeFactory> Mapping of IpAddressData  is not one-to-one with " +
				"Logical Interface objects");
		else {
		//	System.err.println("IpNodeFactory> Proceeding to get ip_address_factory");
			IpAddressDataFactory ip_address_factory =
			  get_context().get_connection_ipAddressDataFactory();

			if (ip_address_factory == null)
				System.err.println("IpNodeFactory> IpAddressDataFactory can not be located..." +
					" No IpAddressData Objects will be created.");
			else {

			//	System.err.println("IpNodeFactoryProvider>******FOUND " +
			//	    ipAdEntAddresses.length +
			//		" IpAddressData Objects");

				int interface_index;
				for (int k = 0; k < ipAdEntAddresses.length; k++) {

				  interface_index = -1;
				  for (int l = 0; l < ifTableIndexes.length; l++) {
					  if (ipAdEntIfIndexes[k] == ifTableIndexes[l]) {
						  interface_index = l;
						  break;
				    }
				  }
				  if (interface_index < 0) {
				    System.err.println("IpNodeFactoryProvider> IpAddressData can not be associated with " +
					    " existing lofical interfaces..." + ipAdEntIfIndexes[k]);
					continue;

				  }
				  NameComponent[] superior_interface = logical_interface_subordinates[interface_index];

				  ip_address_factory.create("IpAddressData_LogicalInterface",
											  superior_interface,
											  new String(),
											  new String[0],
											  ipAdEntAddresses[k].getBytes(),
											  managementIPAddress,
											  snmpPort,
											  supportedSnmpVersions
					);
				}
			}
		  }

		  //proceed to create SnmpMonitor object
		  String[] snmpSupportedConditionalPackages = new String[0];
		  if (vendorName.equalsIgnoreCase("Linux") ||
                		vendorName.equalsIgnoreCase("RedHat Linux")  ||
                		vendorName.equalsIgnoreCase("RedHat")) {

		    snmpSupportedConditionalPackages = new String[1];
		    snmpSupportedConditionalPackages[0] = snmpEnableAuthenTrapPackageType.value;
		  }
          create_snmp_monitor(name, managementIPAddress, snmpPort, supportedSnmpVersions,
							  snmpSupportedConditionalPackages);

		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "successfully created " + Utils.name2string(name));
        return name;

    }

	public void create_snmp_monitor(org.omg.CosNaming.NameComponent[] superior,
									  byte[] managementIPAddress,
								      int snmpPort,
									  int supportedSnmpVersions,
									  String[] supportedConditionalPackages) {

		// SnmpMonitor creation
		try {
			//System.err.println("Create SNMP Monitor is called for parent " +
			 //   Utils.name2string(superior) + "," + SNMP_GROUP_OIDS[0]);
			DataType[] res = this.connector.getBulk(
					SNMP_GROUP_OIDS,
            		new String(managementIPAddress),
            		snmpPort,
					READ_COMMUNITY);

			int count = 0;

			for (int i = 0; i < res.length; i++) {
				try {
					if ( (res[i].value.extract_string().equalsIgnoreCase(
						NO_SUCH_OBJECT)) ||
						(res[i].value.extract_string().equalsIgnoreCase(
						NO_SUCH_INSTANCE)) )
					count ++;
				}
				catch (org.omg.CORBA.BAD_OPERATION badOp) {
					// If a string cannot be extracted, then the result
					// will not be "No Such Object", or "No Such Instance"
					// so no problem then! Catch this exception and ignore it.
				}
			}
			//System.err.println("Res = " + res.length + " count = " + count);
			//if (count < res.length) {
				System.err.println("SnmpProtocolMonitor must be created.");

				SnmpProtocolMonitorFactory snmpf =
				   get_context().get_connection_snmpProtocolMonitorFactory();

				if (snmpf == null) {
					System.err.println("SnmpProtocolMonitorFactory can not be found..." +
						" No SnmpProtocolMonitor Object will be created!");
				}
				else {
					System.err.println("IpNodeFactoryProvider>Invoking SnmpProtocolMonitorFactory...");

					snmpf.create(
						"SnmpProtocolMonitor_IpNode",
						superior,
						"SnmpProtocol",
						supportedConditionalPackages,
						managementIPAddress,
						snmpPort,
						supportedSnmpVersions
					);

				}
			//if}
		}
		catch (SnmpApplicationError e) {
			System.err.println("\nIpNodeFactory:SnmpApplicationError while trying to create SnmpProtocolMonitorFactory");
			System.err.println("Reason:" + e.reason);
		}
		catch (ApplicationError appl_e) {
			System.err.println("\nIpNodeFactory:ApplicationError while trying to create SnmpProtocolMonitorFactory");
			System.err.println("Reason:" + appl_e.getMessage());
		}
		catch (CreateError create_e) {
			System.err.println("\nIpNodeFactory:CreateError while trying to create SnmpProtocolMonitorFactory");
			System.err.println("Reason:" + create_e.getMessage());
		}

	}
	/*** TEMP ******/
    // ==================================================================
    //
    // Public methods for the CCM_ManagedObjectFactoryProvider local interface.
    //
    // ==================================================================
    public org.omg.CosNaming.NameComponent[]
    create_base(String nameBinding,
                org.omg.CosNaming.NameComponent[] superior,
                String reqId)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError {

		return new NameComponent[0];
	}
}
