/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.IpNodeProviderComposition;

import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.UIDType;

import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.AttributeValueChangeType;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.OperationalStateTypeHelper;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.ObjectCreationImpl;
import ist.coach.coachEmfCommon.StateChangedEventImpl;

import ist.coach.coachEmsCommon.SnmpIdentifiers;
import org.omg.CORBA.TCKind;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmsMibComponents/IpNodeProviderComposition/IpNodeProviderHome_impl/IpNodeProvider_impl/mgmtSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class mgmtSegImpl
     extends ist.coach.coachEmsMibComponents.IpNodeProviderComposition.mgmtSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
	org.omg.CORBA.ORB orb = null;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public mgmtSegImpl()
    {
	    orb = org.objectweb.ccm.CORBA.TheORB.getORB();
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmsMibComponents::IpNodeMgmt::create operation.
     */

    public void
    create( org.omg.CosNaming.NameComponent[] name,
				String objectClass,
				java.lang.String[] packages,
				short deletePolicy,
            	intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
				java.lang.String domainName,
				java.lang.String hostname,
				byte[] managementIPAddress,
				int supportedSnmpVersions,
				intt.itu.itut_x780.AdministrativeStateType administrativeState,
				java.lang.String userLabel,
				java.lang.String vendorName,
				java.lang.String version,
				java.lang.String locationName,
				int snmpPort,
				java.lang.String sysName,
				java.lang.String sysContact)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //  DONE : implement
        //
		ist.coach.coachEmfServices.SnmpAdapter.SnmpTrapDaemon config = null;
				if ((config = get_context().get_connection_config()) == null) {
			CreateErrorInfoTypeImpl errorCode =
				new CreateErrorInfoTypeImpl();

			errorCode.error = new UIDType(
				intt.itu.itut_x780.CreateErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			errorCode.details = new String(ExceptionMessages.components_connect_error);
			throw new intt.itu.itut_x780.CreateError(errorCode);
		}
		boolean sysInfoSetPackageIsSupported = false;


		if (IpNodeProviderImpl.elements.containsKey(Utils.name2string(name))) {

			CreateErrorInfoTypeImpl errorCode =
				new CreateErrorInfoTypeImpl();

			errorCode.error = new UIDType(
				intt.itu.itut_x780.CreateErrorConst.moduleName.value,
				intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

			errorCode.details = new String(Utils.name2string(name) +
				" object already exists.");
			throw new intt.itu.itut_x780.CreateError(errorCode);

		}

		IpNodeDataStructure ipNodeData = new IpNodeDataStructure(
												domainName,
												hostname,
												managementIPAddress,
												name,
												packages,
												supportedSnmpVersions,
												administrativeState,
												userLabel,
												vendorName,
												version,
												locationName,
												snmpPort,
												sysName,
												sysContact,
												objectClass,
												deletePolicy,
												sourceIndicator,
												intt.itu.itut_x780.OperationalStateType.enabled);
		synchronized(IpNodeProviderImpl.elements) {
		  IpNodeProviderImpl.elements.put(Utils.name2string(name), ipNodeData);
		}
     	//System.err.println("IpNodeFacade>Before registering to the SNMP Trap service");

		String ipAddress = new String();
        if (managementIPAddress != null)
			ipAddress = new String(managementIPAddress);

        try {
            config.registerIP(name, ipAddress);
        }
        catch( ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
            System.err.println("Could not register IpNode " +
                Utils.name2string(name) + " to the SNMP Trap Service");
            System.err.println("Reason= " + snmp_ex.reason);
            ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.downstreamError.value);

            error_code.details = snmp_ex.reason;

            throw new ApplicationError(error_code);
        }

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);

		//System.err.println("IpNodeProvider  attempts to push object creation alarm...");
		get_context().push_objectCreation(new ObjectCreationImpl(eventTime, name,
										objectClass,
										IpNodeProviderImpl.getUniqueNotificationIdentifier(),
										//ipNodeData.getUniqueNotificationIdentifier(),
										sourceIndicator,
										new AttributeValueType[0]));

		//System.err.println("IpNodeProvider finished create operations...");
    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::TrapCallback::notifyTrap operation.
     */
    public void
    notifyTrap(org.omg.CosNaming.NameComponent[] name,
				java.lang.String community,
				int trapID, int trapType,
			ist.coach.coachEmfServices.SnmpAdapter.DataType[] trapData)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
        //
        //  DONE : implement
        //

		System.err.println("IpNode_F: Notify trap is called for " +
			Utils.name2string(name));

		String key = Utils.name2string(name);

		if (IpNodeProviderImpl.elements.containsKey(key) == false) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("object with name" +
			key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpNodeDataStructure data = (IpNodeDataStructure) IpNodeProviderImpl.elements.get(key);

	    intt.itu.itut_x780.OperationalStateType oldValue = data.operationalState;

	    intt.itu.itut_x780.OperationalStateType newValue = null;


		if (trapType == IpNodeProviderImpl.COLDSTART_TRAP) {

			newValue = intt.itu.itut_x780.OperationalStateType.enabled;

		}
		else
		if (trapType == IpNodeProviderImpl.NETSNMP_SHUTDOWN_TRAP) {

			newValue = intt.itu.itut_x780.OperationalStateType.disabled;

		}
		else {

			System.err.println("IpNode_F does not know how to handle trap of type " +
				trapType);

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpNode_F does not know how to handle" +
			" trap of type " + trapType + ".");

			throw new ApplicationError(error_code);

		}

		if (newValue == oldValue) {

			//System.err.println("No value change occured. Old value is equal to new one.");

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String (" Cannot emmit StateChange Event when no" +
				" state change has occured for IpNode with name " +
				Utils.name2string(name));

			throw new ApplicationError(error_code);
		}

		data.operationalState = newValue;

		long trapTime = 0;
		boolean trapTimeFound = false;

		for (int i = 0; i < trapData.length; i++) {

			if (trapData[i].identifier.equals(SnmpIdentifiers.TIME_OID)) {

				org.omg.CORBA.Any value = trapData[i].value;

				if(value.type().kind().value() != TCKind._tk_longlong) {

					ApplicationErrorInfoTypeImpl error_code =
						new ApplicationErrorInfoTypeImpl();

					error_code.error = new UIDType(
						intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
						intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

					error_code.details = new String ("Could not retrieve event time " +
						" for trap. Object with Snmp Object Identifier " + SnmpIdentifiers.TIME_OID +
			 			" is not of type long, as expected.");

					throw new ApplicationError(error_code);

				}

				trapTime = value.extract_longlong();
				trapTimeFound = true;
				break;
			}

		}

		if (trapTimeFound == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve event time " +
				" for trap.");

			throw new ApplicationError(error_code);
		}

		//org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(trapTime, 0,(short) 0,(short) 0);
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
						0,(short) 0,(short) 0);

//		int notificationId = data.getUniqueNotificationIdentifier();
		int notificationId = IpNodeProviderImpl.getUniqueNotificationIdentifier();

		String sourceClass = data.objectclass;

		SourceIndicatorType sourceIndicator = SourceIndicatorType.unknown;

		org.omg.CORBA.Any oldValue_any =  orb.create_any();
		OperationalStateTypeHelper.insert(oldValue_any, oldValue);

		org.omg.CORBA.Any newValue_any =  orb.create_any();
		OperationalStateTypeHelper.insert(newValue_any, newValue);

		AttributeValueChangeType [] changedValues = new AttributeValueChangeType[1];
		changedValues[0] = new AttributeValueChangeType(
				"operationalState",
				oldValue_any,
				newValue_any);

		StateChangedEventImpl stateChangedEvent = new StateChangedEventImpl(
				eventTime,
				name,
				sourceClass,
				notificationId,
			  	sourceIndicator,
				//new AttributeValueChangeType[0]);
				changedValues);

		System.err.println("IpNodeProvider>Before pushing StateChange event with identifier " +
			stateChangedEvent.notificationIdentifier + " for " +
			Utils.name2string(stateChangedEvent.source) + " of objectclass " +
			stateChangedEvent.sourceClass + " generated after SNMP agent " +
			"has been up for " + stateChangedEvent.eventTime.time +
			" caused by an action of type " + sourceIndicator + "." );

		get_context().push_stateChange(stateChangedEvent);

    }


    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::TrapCallback::facade_name operation.
     */
    public String
    facade_name()
    {
        //
        // DONE : Implement
        //
        return get_main_segment().facade_name();
    }

}
