/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents.IpProtocolMonitorProviderComposition;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.AttributeValueType;

import ist.coach.coachEmfCommon.Utils;

import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.IpProtocolMonitorValueType;
//import ist.coach.coachEmsMib.IpProtocolMonitor_F;
//import ist.coach.coachEmsMibComponents.IpProtocolMonitorProviderHelper;
import ist.coach.coachEmsCommon.SnmpIdentifiers;

import ist.coach.coachEmsCommon.IpProtocolMonitorValueTypeImpl;
import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;
import ist.coach.coachEmfServices.EmfBasicLog.*;
import java.util.Hashtable;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/IpProtocolMonitorProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class IpProtocolMonitorProviderImpl
     extends ist.coach.coachEmsMibComponents.IpProtocolMonitorProviderComposition.IpProtocolMonitorProvider_impl
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/

    org.omg.CORBA.ORB orb = null;
    private String _facade_name;

    protected static  Hashtable elements;
	private static int notifId = 12000;
	private BasicLog logSupport;

    ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	private static final String IP_PROTOCOL_CONFIG_PACKAGE = "ipProtocolConfigurationSetPackage";

	private static final String READ_COMMUNITY = SnmpIdentifiers.READ_COMMUNITY;
	private static final String WRITE_COMMUNITY = SnmpIdentifiers.WRITE_COMMUNITY;

    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    IpProtocolMonitorProviderImpl()
    {
        elements = new Hashtable();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================

    // ==================================================================
    //
    // Public methods.
    //

    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((connector = get_context().get_connection_connector()) == null)
            throw new org.omg.Components.InvalidConfiguration();
		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		orb = org.objectweb.ccm.CORBA.TheORB.getORB();

        System.err.println("IpProtocolMonitorProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     **/
    public void
    facade_name(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipForwardingGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipForwardingGet operation.
     **/
    public int
    ipForwardingGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipForwaringData = null;

		try {
			ipForwaringData = connector.get(
				SnmpIdentifiers.IP_FWD_TYPE_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipForwaring " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FWD_TYPE_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ip forwarding: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipForwaringData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipForwaring " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FWD_TYPE_OID +
				" is not of type integer, as expected.");

			throw new ApplicationError (error_code);
		}

		int ipForwarding = value.extract_long();

		return ipForwarding;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipForwardingSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipForwardingSet operation.
     **/
    public void
    ipForwardingSet(org.omg.CosNaming.NameComponent[] name, int ipForwarding)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		if (!Utils.packageIsSupported(IP_PROTOCOL_CONFIG_PACKAGE, packagesGet(name))) {
			System.err.println("Package " + IP_PROTOCOL_CONFIG_PACKAGE + " is not supported " +
				"by IpProtocolMonitor Object " + key);

			throw new ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException();
		}

		org.omg.CORBA.Any value = orb.create_any();

		value.insert_long(ipForwarding);
		DataTypeImpl ipForwardingData = new DataTypeImpl(
			SnmpIdentifiers.IP_FWDDATAGRAMS_OID,
			value,
			SnmpSMI.SMI_INTEGER);

		try {
			connector.set(
				ipForwardingData,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				WRITE_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("Could not set ipForwarding " +
				"for IpProtocolMonitor Object with name " + key + ".");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error setting ip forwarding: " + e.reason);
			throw new ApplicationError(error_code);

		}


    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipDefaultTTLGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipDefaultTTLGet operation.
     **/
    public int
    ipDefaultTTLGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) elements.get(key);

	DataType ipDefaultTTLData = null;

	try {
		ipDefaultTTLData = connector.get(
			SnmpIdentifiers.IP_DEFAULT_TTL_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipDefaultTTL " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_DEFAULT_TTL_OID +
				" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ip default TTL: " + e.reason);

		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipDefaultTTLData.value;

	if (value.type().kind().value() != TCKind._tk_long) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipDefaultTTL " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_DEFAULT_TTL_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	}

	int ipDefaultTTL = value.extract_long();

	return ipDefaultTTL;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipDefaultTTLSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipDefaultTTLSet operation.
     **/
    public void
    ipDefaultTTLSet(org.omg.CosNaming.NameComponent[] name, int ipDefaultTTL)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		if (!Utils.packageIsSupported(IP_PROTOCOL_CONFIG_PACKAGE, packagesGet(name))) {
			System.err.println("Package " + IP_PROTOCOL_CONFIG_PACKAGE + " is not supported " +
				"by IpProtocolMonitor Object " + key);

			throw new ist.coach.coachEmsMib.NOipProtocolConfigurationSetPackageException();
		}

		org.omg.CORBA.Any value = orb.create_any();

		value.insert_long(ipDefaultTTL);
		DataTypeImpl ipDefaultTTLData = new DataTypeImpl(
			SnmpIdentifiers.IP_DEFAULT_TTL_OID,
			value,
			SnmpSMI.SMI_INTEGER);

		try {
			connector.set(
				ipDefaultTTLData,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				WRITE_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("Could not set ipDefaultTTL " +
				"for IpProtocolMonitor Object with name " + key + ".");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error setting ip default TTL: " + e.reason);
			throw new ApplicationError(error_code);

		}

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInReceivesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInReceivesGet operation.
     **/
    public long
    ipInReceivesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) elements.get(key);

	DataType ipInReceivesData = null;

	try {
		ipInReceivesData = connector.get(
			SnmpIdentifiers.IP_INRECEIVE_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInReceivesData " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INRECEIVE_OID +
				" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipInReceivesData: " + e.reason);

		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInReceivesData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInReceivesData " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INRECEIVE_OID +
			" is not of type integer, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInReceives = value.extract_longlong();

	return ipInReceives;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInHdrErrorsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInHdrErrorsGet operation.
     **/
    public long
    ipInHdrErrorsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) elements.get(key);

	DataType ipInHeaderErrorsData = null;

	try {
		ipInHeaderErrorsData = connector.get(
			SnmpIdentifiers.IP_INHDRERRORS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInErrorHeaders " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INHDRERRORS_OID +
				" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipInErrorHeaders: " + e.reason);

		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInHeaderErrorsData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInHeaderErrors " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INHDRERRORS_OID +
			" is not of type long, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInHeaderErrors = value.extract_longlong();

	return ipInHeaderErrors;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInAddrErrorsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInAddrErrorsGet operation.
     **/
    public long
    ipInAddrErrorsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DOPE : implement
        //
	String key = Utils.name2string(name);

	if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String("object with name " +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpProtocolMonitorDataStructure data =
		(IpProtocolMonitorDataStructure) elements.get(key);

	DataType ipInAddrErrorsData = null;

	try {
		ipInAddrErrorsData = connector.get(
			SnmpIdentifiers.IP_INADDRERRORRS_OID,
			new String (data.mgmtIpAddress),
			data.getSnmpPort(),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInAddrErrors " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INADDRERRORRS_OID +
				" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipInAddrErrors: " + e.reason);

		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInAddrErrorsData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInAddrErrors " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INADDRERRORRS_OID +
			" is not of type long, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInAddrErrors = value.extract_longlong();

	return ipInAddrErrors;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipForwDatagramsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipForwDatagramsGet operation.
     **/
    public long
    ipForwDatagramsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipForwardedDatagramsData = null;

		try {
			ipForwardedDatagramsData = connector.get(
				SnmpIdentifiers.IP_FWDDATAGRAMS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipForwardedDatagrams " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FWDDATAGRAMS_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipForwardedDatagrams: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipForwardedDatagramsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipForwardedDatagrams " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FWDDATAGRAMS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipForwardedDatagrams = value.extract_longlong();

		return ipForwardedDatagrams;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInUnknownProtosGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInUnknownProtosGet operation.
     **/
    public long
    ipInUnknownProtosGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipInUnknownProtosData = null;

		try {
			ipInUnknownProtosData = connector.get(
				SnmpIdentifiers.IP_INUNKNOWNPROTO_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ipInUnknownProtos " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INUNKNOWNPROTO_OID +
				" does not exist.");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipInUnknownProtos: " + e.reason);

		throw new ApplicationError (error_code);
	}

	org.omg.CORBA.Any value = ipInUnknownProtosData.value;

	if (value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ipInUnknownProtos " +
			"for IpProtocolMonitor Object with name " + key + ":" +
			" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INUNKNOWNPROTO_OID +
			" is not of type long, as expected.");

		throw new ApplicationError (error_code);
	}

	long ipInUnknownProtos = value.extract_longlong();

	return ipInUnknownProtos;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInDiscardsGet operation.
     **/
    public long
    ipInDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipInDiscardsData = null;

		try {
			ipInDiscardsData = connector.get(
				SnmpIdentifiers.IP_INDISCARDS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipInDiscards " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INDISCARDS_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipInDiscards: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipInDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipInDiscards " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INDISCARDS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipInDiscards = value.extract_longlong();

		return ipInDiscards;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipInDeliversGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipInDeliversGet operation.
     **/
    public long
    ipInDeliversGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipInDeliversData = null;

		try {
			ipInDeliversData = connector.get(
				SnmpIdentifiers.IP_INDELIVERS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipInDelivers " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INDELIVERS_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipInDelivers: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipInDeliversData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipInDelivers " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_INDELIVERS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipInDelivers = value.extract_longlong();

		return ipInDelivers;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipOutRequestsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipOutRequestsGet operation.
     **/
    public long
    ipOutRequestsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipOutRequestsData = null;

		try {
			ipOutRequestsData = connector.get(
				SnmpIdentifiers.IP_OUTREQUESTS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipOutRequests " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_OUTREQUESTS_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipOutRequests: " + e.reason);

			  throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipOutRequestsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipOutRequests " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_OUTREQUESTS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipOutRequests = value.extract_longlong();

		return ipOutRequests;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipOutDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipOutDiscardsGet operation.
     **/
    public long
    ipOutDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipOutDiscardsData = null;

		try {
			ipOutDiscardsData = connector.get(
				SnmpIdentifiers.IP_OUTDISCARDS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipOutDiscards " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_OUTDISCARDS_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipOutDiscards: " + e.reason);

			  throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipOutDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipOutDiscards " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_ROUTING_DISCARDS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipOutDiscards = value.extract_longlong();

		return ipOutDiscards;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipOutNoRoutesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipOutNoRoutesGet operation.
     **/
    public long
    ipOutNoRoutesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipNoRoutesData = null;

		try {
			ipNoRoutesData = connector.get(
				SnmpIdentifiers.IP_NOROUTE_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipNoRoutes " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_NOROUTE_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipNoRoutes: " + e.reason);

			 throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipNoRoutesData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipNoRoutes " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_NOROUTE_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipNoRoutes = value.extract_longlong();

		return ipNoRoutes;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmTimeoutGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmTimeoutGet operation.
     **/
    public int
    ipReasmTimeoutGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipReasmTimeoutData = null;

		try {
			ipReasmTimeoutData = connector.get(
				SnmpIdentifiers.IP_REASMTIMEOUT_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmTimeouts " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMTIMEOUT_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipReasmTimeouts: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmTimeoutData.value;

		if (value.type().kind().value() != TCKind._tk_long) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmTimeouts " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMTIMEOUT_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		int ipReasmTimeouts = value.extract_long();

		return ipReasmTimeouts;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmReqdsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmReqdsGet operation.
     **/
    public long
    ipReasmReqdsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipReasmReqsData = null;

		try {
			ipReasmReqsData = connector.get(
				SnmpIdentifiers.IP_REASMREQ_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmReqs " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMREQ_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipReasmReqs: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmReqsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmReqs " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMREQ_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipReasmReqs = value.extract_longlong();

		return ipReasmReqs;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmOKsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmOKsGet operation.
     **/
    public long
    ipReasmOKsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipReasmOKsData = null;

		try {
			ipReasmOKsData = connector.get(
				SnmpIdentifiers.IP_REASMOK_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmOKs " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMOK_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipReasmOKs: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmOKsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmOKs " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMOK_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipReasmOKs = value.extract_longlong();

		return ipReasmOKs;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipReasmFailsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipReasmFailsGet operation.
     **/
    public long
    ipReasmFailsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipReasmFailsData = null;

		try {
			ipReasmFailsData = connector.get(
				SnmpIdentifiers.IP_REASMFAIL_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipReasmFails " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMFAIL_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipReasmFails: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipReasmFailsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipReasmFails " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_REASMFAIL_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipReasmFails = value.extract_longlong();

		return ipReasmFails;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipFragOKsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipFragOKsGet operation.
     **/
    public long
    ipFragOKsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipFragOKsData = null;

		try {
			ipFragOKsData = connector.get(
				SnmpIdentifiers.IP_FRAGOK_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipFragOKs " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FRAGOK_OID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipFragOKs: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipFragOKsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipFragOKs " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FRAGOK_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipFragOKs = value.extract_longlong();

		return ipFragOKs;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipFragFailsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipFragFailsGet operation.
     **/
    public long
    ipFragFailsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipFragFailsData = null;

		try {
			ipFragFailsData = connector.get(
				SnmpIdentifiers.IP_FRAGFAIL_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipFragFails " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FRAGFAIL_OID +
					" does not exist.");

			  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipFragFails: " + e.reason);
			  throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipFragFailsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipFragFails " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FRAGFAIL_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipFragFails = value.extract_longlong();

		return ipFragFails;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipFragCreatesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipFragCreatesGet operation.
     **/
    public long
    ipFragCreatesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipFragCreatesData = null;

		try {
			ipFragCreatesData = connector.get(
				SnmpIdentifiers.IP_FRAGCREATE_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipFragCreates " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FRAGCREATE_OID +
					" does not exist.");

			  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipFragCreates: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipFragCreatesData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipFragCreates " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_FRAGCREATE_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipFragCreates = value.extract_longlong();

		return ipFragCreates;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitor_F/ipRoutingDiscardsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitor_F::ipRoutingDiscardsGet operation.
     **/
    public long
    ipRoutingDiscardsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		DataType ipRoutingDiscardsData = null;

		try {
			ipRoutingDiscardsData = connector.get(
				SnmpIdentifiers.IP_ROUTING_DISCARDS_OID,
				new String (data.mgmtIpAddress),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipRoutingDiscards " +
					"for IpProtocolMonitor Object with name " + key + ":" +
					" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_ROUTING_DISCARDS_OID +
					" does not exist.");


			  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipRoutingDiscards: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipRoutingDiscardsData.value;

		if (value.type().kind().value() != TCKind._tk_longlong) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve ipRoutingDiscards " +
				"for IpProtocolMonitor Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + SnmpIdentifiers.IP_ROUTING_DISCARDS_OID +
				" is not of type long, as expected.");

			throw new ApplicationError (error_code);
		}

		long ipRoutingDiscards = value.extract_longlong();

		return ipRoutingDiscards;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/nameGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        //  DONE : implement
        //
        return Utils.string2name(_facade_name);
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/objectClassGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     **/
    public java.lang.String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		return data.objectclass;

    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/attributesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     **/
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		IpProtocolMonitorValueTypeImpl ipProtocolMonitorValueType =
			new IpProtocolMonitorValueTypeImpl(
				ipForwardingGet(name),
				ipDefaultTTLGet(name),
				ipInReceivesGet(name),
				ipInHdrErrorsGet(name),
				ipInAddrErrorsGet(name),
				ipForwDatagramsGet(name),
				ipInUnknownProtosGet(name),
				ipInDiscardsGet(name),
				ipInDeliversGet(name),
				ipOutRequestsGet(name),
				ipOutDiscardsGet(name),
				ipOutNoRoutesGet(name),
				ipReasmTimeoutGet(name),
				ipReasmReqdsGet(name),
				ipReasmOKsGet(name),
				ipReasmFailsGet(name),
				ipFragOKsGet(name),
				ipFragFailsGet(name),
				ipFragCreatesGet(name),
				ipRoutingDiscardsGet(name),

				data.name,
				data.objectclass,
				data.packages,
				data.sourceIndicator,
				data.deletePolicy
			);
			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "attributesGet finished successfully");
			return ipProtocolMonitorValueType;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/packagesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     **/
    public java.lang.String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

        return data.packages;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/creationSourceGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     **/
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

		return data.sourceIndicator;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/deletePolicyGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     **/
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpProtocolMonitorDataStructure data =
			(IpProtocolMonitorDataStructure) elements.get(key);

        return data.deletePolicy;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/destroy:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     **/
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //

	if (!elements.containsKey(Utils.name2string(name))) {

            ApplicationErrorInfoTypeImpl error_code =
            new ApplicationErrorInfoTypeImpl();

            error_code.error = new UIDType(
            intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
            intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

            error_code.details = new String ("object with name " +
            Utils.name2string(name) + " does not exist.");

            throw new ApplicationError(error_code);

	}
	IpProtocolMonitorDataStructure ipProtocolMonitorData = null;
	synchronized(elements) {
	    ipProtocolMonitorData =
	 		(IpProtocolMonitorDataStructure) elements.remove(
			Utils.name2string(name));
	}
	org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
		0, (short) 0, (short) 0);
	get_context().push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
						ipProtocolMonitorData.objectclass,
						getUniqueNotificationIdentifier(),
//						ipProtocolMonitorData.getUniqueNotificationIdentifier(),
						ipProtocolMonitorData.sourceIndicator,
						new AttributeValueType[0]));

		Utils.pretty_log(logSupport,  Utils.name2string(name),
			ipProtocolMonitorData.objectclass, //objectClassGet(name),
		  (short) LogSeverity._Info,
		  "successfully removed from management system");

    }
    // ==================================================================
    //
    // Public methods for the ::coachEmsMibComponents::CCM_IpProtocolMonitorMgmt local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMibComponents/IpProtocolMonitorMgmt/facade_name:1.0
    //
    /**
     **  Implementation of the ::coachEmsMibComponents::IpProtocolMonitorMgmt::facade_name operation.
     **/
    public java.lang.String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    protected static int getUniqueNotificationIdentifier() {

		notifId++;
        return notifId;
	}


}
