@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL - LUCENT
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Wim Hellenthal.
rem #
rem # Contributor(s): --------------------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Starting the COACH Tracing server.
rem #
rem # ====================================================================

setlocal

rem # Check if the OpenCCM Platform is installed.
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

rem # Check if the Naming Service is started.
if exist %OpenCCM_CONFIG_DIR%\NameService.IOR goto :run

echo Error: The Naming Service is not started!
goto :eof

:run

set jvm_args=-DFCGI_PORT=10000
set args="%*  %OpenCCM_HOMEDIR%/xml/launcher/coach_tracing.xml "

call launcher fork "%jvm_args%" %args% %OpenCCM_CONFIG_DIR%\TracingServer.output  %OpenCCM_CONFIG_DIR%\TracingServer.PID

echo The COACH Tracing server is started.
