/*====================================================================

created on 20 mars 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.Components.ConnectionDescription;
import org.omg.Components.Cookie;

/**
 * @author hameau
 */

public class ReceptaclePortInstanceImpl
extends PortInstanceImpl
implements ReceptaclePortInstance {

  protected InterfaceInstance _interface_instance;
  protected int               _nb_connexion; 
  protected Table             _connexions;
  
  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#interface_instance()
   */
  public InterfaceInstance interface_instance()
  {
    return _interface_instance;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#interface_instance(org.objectweb.ccm.Containers.MetaInformation.InterfaceInstance)
   */
  public void interface_instance(InterfaceInstance value)
  {
    _interface_instance = value;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#nb_connexion()
   */
  public int nb_connexion()
  {
    return _nb_connexion;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#nb_connexion(int)
   */
  public void nb_connexion(int value)
  {
    _nb_connexion = value;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#connexions()
   */
  public ConnectionDescription[] connexions()
  {
    return (ConnectionDescription[]) _connexions.values().toArray(new ConnectionDescription[0]);
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#connexions(org.omg.Components.ConnectionDescription[])
   */
  public void connexions(ConnectionDescription[] value)
  {
    // TODO : to implement !
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#add_connexion_info(org.omg.Components.ConnectionDescription)
   */
  public void add_connexion_info(ConnectionDescription conn)
  {
    _connexions.put(conn.ck, conn);   
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ReceptaclePortInstanceOperations#remove_connexion_info(org.omg.Components.ConnectionDescription)
   */
  public void remove_connexion_info(ConnectionDescription conn)
  {
    _connexions.remove(conn.ck);    
  }
    
  public ConnectionDescription get_connexion(Cookie ck)
  {
     return (ConnectionDescription)_connexions.get(ck);
  }
}
