/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.binder;

// Local Interface Import Statements
import org.objectweb.ccm.descriptor.componentassembly.beans.ConnectinterfaceBeanImpl;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.HandlerBase;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
/**
 * This handler is used to produce connectinterfacedeployer from an
 * connectinterface bean .
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ConnectinterfaceDeployerHandler 
       extends HandlerBase 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private ConnectinterfaceDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    public Object 
    getInstance(ConnectinterfaceBeanImpl connect)
    throws InitializationError 
    {
        if(_deploy==null){
            _deploy=new ConnectinterfaceDeployer();
            applyCommonConfig(_deploy);
            
            _deploy.connectConnectinterface(connect);
            if(connect.getComponentsupportedinterface()!=null)
            _deploy.connectComponentsupportedinterfaceDeployer
                ((ComponentsupportedinterfaceDeployer)getDeployer
                    (connect.getComponentsupportedinterface()));
           if(connect.getExistinginterface()!=null)
            _deploy.connectExistinginterfaceDeployer
                ((ExistinginterfaceDeployer)getDeployer
                    (connect.getExistinginterface())); 
           if(connect.getHomeinterface()!=null)
            _deploy.connectHomeinterfaceDeployer
                ((HomeinterfaceDeployer)getDeployer(connect.getHomeinterface()));                 
           if(connect.getProvidesport()!=null)
            _deploy.connectProvidesportDeployer
                ((ProvidesportDeployer)getDeployer(connect.getProvidesport()));
           if(connect.getUsesport()!=null)
            _deploy.connectUsesportDeployer
                ((UsesportDeployer)getDeployer(connect.getUsesport()));
            _deploy.initialize(); 
        }
     
        return (_deploy);
    }

}
