/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.softpkg.ccm;


/**
 * The link deployer provide an URL on a ressource
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class LinkDeployer 
       extends LinkDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    //temporary file to store the remote ressource
    private java.io.File tmpFile;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    private String 
    getValeur()
    {
        if(getLink().getHref()!=null)
            return getLink().getHref().trim();
        else return getLink().getValue().trim();
    }
    
    private java.io.InputStream
    getInputStreamInternal()
    throws java.io.IOException
    {

        
        java.net.URL url=new java.net.URL(getValeur());
        
        //The required file is a local file we don't copy it
        if(getValeur().startsWith("file:"))
            return url.openStream();


       //file is already prensent in the deployer
       if(tmpFile!=null)
        return new java.io.FileInputStream(tmpFile);

       //File was already downloaded by an another deployer
       if(getRootDeployerContext().isAlreadyDownloaded(getValeur()))
       {
            tmpFile=getRootDeployerContext().getTemporaryFile(getValeur());
            return new java.io.FileInputStream(tmpFile);
       }
            
        //file was not yet downloaded
        tmpFile=java.io.File.createTempFile(url.getFile(),System.currentTimeMillis()+"");
        java.io.FileOutputStream fos=new java.io.FileOutputStream(tmpFile);
        java.io.InputStream is=url.openStream();
        byte [] buff=new byte[32000];
        int readed=is.read(buff,0,32000);        
        while(readed>0)
        {                                         
             fos.write(buff,0,readed);
             readed=is.read(buff,0,32000);
        }
        fos.close();
        getRootDeployerContext().connectTemporaryFile(tmpFile,getValeur());
        return new java.io.FileInputStream(tmpFile);
    }
    // ==================================================================
    //
    //  Public methods.
    //
    // ================================================================== 
    /**
     * Return the stringified URL to the ressource.
     */   
    public String
    getReference()
    {
        return getValeur();
    }



    public java.io.InputStream
    getInputStream()
    throws java.io.IOException
    {
        java.io.InputStream is=getInputStreamInternal();
        getRootDeployerContext().connectOpenInputStream(is);
        return is;
    }

}
