/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.generator.psdl.api;

import org.objectweb.corba.ast.api.Scope;
import org.objectweb.corba.generator.common.lib.GenerationException;

/**
 * This is the PSDLtoJavaGenerator interface.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</A>
 */

public interface PSDL2JavaGenerator
         extends org.objectweb.corba.generator.common.api.GeneratorBase
{
    /**
     * Get the generator translator utility class.
     *
     * @return The translator.
     **/
    public org.objectweb.corba.generator.translator.idl2java.api.PSDL_JavaTranslator
    getTranslator();

    /**
     * Get the java Repository.
     *
     * @return The translator.
     **/
    public org.objectweb.corba.generator.java.ast.api.Repository
    getJavaRepository();

    /**
     * Generate java files for the PSDL JAVA Mappings.
     *
     * @param base_dir - The base directory where files will be generated.
     * @param scope - The scope to map.
     * @param user_properties_file - The name of user jdo properties file.
     **/
    public void
    psdl_to_java(String base_dir,
                 Scope scope,
                 String user_properties_file)
    throws GenerationException;
}
