/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.CosTrading;

/** The Java Swing imports. */
import javax.swing.JOptionPane;

import java.awt.Component;

/** The administration console's API imports */
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;

/** The OMG CosTrading imports. */
import org.omg.CosTradingRepos.ServiceTypeRepository;

import org.objectweb.openccm.browser.CosTrading.gui.*;

/**
 * This action adds some service types describe in a Trading Service
 * Type Descriptor file. <b>Warning</b>: this action only uses the
 * default OpenCCM reference of a trading service. 
 *
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a>
 * @version 0.1
 */
public class AddServiceTypes implements MenuItem {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    public int getStatus(TreeView arg0){
        return MenuItem.ENABLED_STATUS;
    }

    public void actionPerformed(MenuItemTreeView e) {
        ServiceTypeRepository parent = (ServiceTypeRepository)e.getSelectedObject();

        AddServiceTypesPanel stp = new AddServiceTypesPanel();
        
        int result =
            JOptionPane.showOptionDialog(
                (Component) e.getActionEvent().getSource(),
                stp,
                "Add trading service types",
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.PLAIN_MESSAGE,
                null,
                null,
                null);

        if (result == 0) {
            String filename = stp.getFileName();
            org.objectweb.openccm.services.trading.TypeRepositoryFeed trf = new org.objectweb.openccm.services.trading.TypeRepositoryFeed();
            trf.run(new String[] {filename});
        }
    }
}
