/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic.
Contributor(s):  ______________________________________.

===========================================================================*/


package org.objectweb.openccm.browser.DCI;

import org.objectweb.util.browser.api.Panel;
import org.objectweb.util.browser.api.TreeView;

import javax.swing.JPanel;
import java.awt.Color;

/**
 * NodeManagerModel panel
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Frederic Briclet</a>
 * @version 0.1
 */
public class NodeManagerPanel 
    implements Panel {

    private JPanel panel_;

    public NodeManagerPanel(){
        panel_ = new JPanel();
        panel_.setBackground(Color.white);
    }

    public void selected(TreeView treeView) {
        org.objectweb.openccm.OpenCCM_DCI.NodeManager
            node=(org.objectweb.openccm.OpenCCM_DCI.NodeManager)
            treeView.getSelectedObject();        
        org.ist.coach.DCI.DCIDescriptor[] desc=
            node.provide_node_information().get_node_properties();

        panel_.add(new javax.swing.JTextArea(desc[0].descriptor));
    }

    public JPanel getPanel() {
        return panel_;
    }

    public void unselected(TreeView treeView) {
        // Nothing to do !
    }


}
