/*====================================================================

created on 18 aot 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class InterfaceInstanceListImpl
extends LocalObject
implements InterfaceInstanceList
{
  private Table _interfaces; 
  
  public InterfaceInstanceListImpl()
  {
    _interfaces = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InterfaceInstanceListOperations#get_interface_instance(java.lang.String)
   */
  public InterfaceInstance 
  get_interface_instance(String name) 
  throws InvalidName
  {
    InterfaceInstance result = (InterfaceInstance) _interfaces.get(name);
    if(result == null)
      throw new InvalidName();
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InterfaceInstanceListOperations#get_named_interface_instances(java.lang.String[])
   */
  public InterfaceInstance[] 
  get_named_interface_instances(String[] names) 
  throws InvalidName
  {
    InterfaceInstance[] result = new InterfaceInstance[names.length];

   // Iterate on all the connections.

   int i = 0;
   for(i=0;i<names.length;i++)
   {
     result[i] = (InterfaceInstance)_interfaces.get(names[i]);
   
     if(result[i] == null)
     {
       throw new InvalidName();
     }
    }
 
   return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InterfaceInstanceListOperations#get_all_interface_instances()
   */
  public InterfaceInstance[] 
  get_all_interface_instances()
  {
    InterfaceInstance[] result = new InterfaceInstance[_interfaces.size()];

     // Iterate on all the connections.
     int idx = 0;
     for(java.util.Enumeration enum = _interfaces.elements(); enum.hasMoreElements(); )
     {
       InterfaceInstance info = (InterfaceInstance)enum.nextElement();
         result[idx++] = info;
     }
     return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InterfaceInstanceListOperations#add_interface_instance(org.objectweb.ccm.Containers.MetaInformation.InterfaceInstance)
   */
  public void add_interface_instance(InterfaceInstance cpi)
  {
    
    String key = cpi.type_reference().name() + cpi.toString().substring(cpi.toString().lastIndexOf("@"));
    _interfaces.put(new String(cpi.type_reference().name()+cpi),cpi);
  
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.InterfaceInstanceListOperations#remove_interface_instance(java.lang.String)
   */
  public void remove_interface_instance(String name) 
  throws InvalidName
  {
    Object result = _interfaces.remove(name);
  
    if (result == null) throw new InvalidName();
  }
}
